// example how to write your own send/receivable classes
// class 'group' specification

#ifndef _GROUP_CLASS_INCLUDE
#define _GROUP_CLASS_INCLUDE

// base class 'cppvmObject'
#include "pvm_obj.h"
// 'cppvmString' class
#include "pvm_str.h"

// unique(!) message tag for this class
// must not be in range [99900-99999] (used by 'PVM*' classes)
#define CPPvmMsgTagClassGroup 3

class groupClass : public cppvmObject{
public:

// constructors/destructor
  groupClass();
  groupClass(const groupClass&);
  virtual ~groupClass();

// overloaded operators
  groupClass& operator=(const groupClass&);
  bool operator==(const groupClass&);
  bool operator==(const groupClass&) const;

// stream methods
  virtual void cppvmScanFrom(istream& = cin);
  virtual void cppvmPrintOn(ostream& = cout);

// transfer method
// used by send/receive/distributed/mailbox messages of this class
  virtual void cppvmTransfer();
    
// pvm message tag declaration
  CPPvmMethodsDeclarationVariable

public:
  void setName(cppvmString groupName_);
  void setId(int groupId_);

public:
  cppvmString groupName;
  int groupId;
};

#endif
