// stl wrapper class example

#ifndef _PARAMVECTOR_INCLUDE
#define _PARAMVECTOR_INCLUDE

// include cppvm types
#include "cppvm.h"

// unique(!) message tag for this class
#define CPPvmMsgTagClassParamVector 22

#ifndef CPPvmDoNotUseStdNamespace
// use vector
using std::vector;
#endif

/////////////////
// declaration //
/////////////////

template <class T>
class paramVector : public cppvmObject{
public:

// constructor/destructor
  paramVector();
  virtual ~paramVector();

// transfer method
  virtual void cppvmTransfer();
    
// pvm message tag declaration
  CPPvmMethodsDeclaration(CPPvmMsgTagClassParamVector)

  void print(){
    cout << name.c_str() << " ";
    typename vector<T>::iterator i;
    for (i=params.begin(); i != params.end() ; i++) {
      cout << *i << " ";
    }
  }
  
public:
  string name;
  vector<T> params;
};

////////////////
// definition //
////////////////

// constructors
template <class T>
paramVector<T>::paramVector()
    : cppvmObject()
{
}

// destructor
template <class T>
paramVector<T>::~paramVector()
{
}

// cppvmTransfer
template <class T>
void
paramVector<T>::cppvmTransfer()
{
  cppvmTransferStlString(name,1);
  cppvmTransferStlVector(params,1);
}

#endif




