// template class example

#ifndef _MYTEMPLATE_INCLUDE
#define _MYTEMPLATE_INCLUDE

// include cppvm types
#include "cppvm.h"

// unique(!) message tag for this class
#define CPPvmMsgTagClassMyTemplate 333

// template array size
#define MyTemplateArraySize 4

/////////////////
// declaration //
/////////////////

template <class T>
class myTemplate : public cppvmObject{
public:

// constructor/destructor
  myTemplate();
  virtual ~myTemplate();

// transfer method
  virtual void cppvmTransfer();
    
// pvm message tag declaration
  CPPvmMethodsDeclaration(CPPvmMsgTagClassMyTemplate)

public:
  int integerValue;
  cppvmFloat floatValue;
  T templSingle;
  T* templArray;
  
};

////////////////
// definition //
////////////////

// default constructor
template <class T>
myTemplate<T>::myTemplate()
    : cppvmObject()
{
  integerValue = 0;
  floatValue = 0.0;
  templArray = new T [MyTemplateArraySize];
}

// destructor
template <class T>
myTemplate<T>::~myTemplate()
{
  delete [] templArray;
}

// cppvmTransfer
template <class T>
void
myTemplate<T>::cppvmTransfer()
{
  // transfer standard types (int, float, double, ...)
  // with the functions 'cppvmTransfer*'
  cppvmTransferInt(&integerValue);
  // transfer classes derived from cppvmObject 
  // call the methods 'cppvmTransfer'
  floatValue.cppvmTransfer();
  // transfer template types 
  // with the functions 'cppvmTransferTemplate<T>'
  cppvmTransferTemplate<T>(templSingle, 1);
  cppvmTransferTemplate<T>(templArray, MyTemplateArraySize, 1);
}

#endif




