// example how to write your own send/receivable classes
// class 'user' specification

#ifndef _USER_CLASS_INCLUDE
#define _USER_CLASS_INCLUDE

// base class 'cppvmObject'
#include "pvm_obj.h"
// 'cppvmString' class
#include "pvm_str.h"
// 'group' class
#include "group.h"


// unique(!) message tag for this class
// must not be in range [99900-99999] (used by 'PVM*' classes)
#define CPPvmMsgTagClassUser 1

class userClass : public cppvmObject{
public:

// constructors/destructor
  userClass();
  userClass(cppvmString name_, int id_,
	    cppvmString groupName, int groupId);
  userClass(const userClass&);
  virtual ~userClass();

// overloaded operators
  userClass& operator=(const userClass&);
  bool operator==(const userClass&);
  bool operator==(const userClass&) const;

// stream methods
  virtual void cppvmScanFrom(istream& = cin);
  virtual void cppvmPrintOn(ostream& = cout);

// transfer method
// used by send/receive/distributed/mailbox messages of this class
  virtual void cppvmTransfer();
    
// pvm message tag declaration
  CPPvmMethodsDeclarationVariable

public:
  cppvmString name;
  int id;
  groupClass group;
};

// receive function for collections
// normal c-function, not a method
cppvmObject*
userClassRecColl(int classId);

#endif
