// example how to write your own send/receivable classes
// class 'userkey' specification

#ifndef _USERKEY_CLASS_INCLUDE
#define _USERKEY_CLASS_INCLUDE

// base class 'userClass'
#include "user.h"

// unique(!) message tag for this class
// must not be in range [99900-99999] (used by 'PVM*' classes)
#define CPPvmMsgTagClassUserkey 2

class userKeyClass : public userClass{
public:

// constructors/destructor
  userKeyClass();
  userKeyClass(cppvmString name_, int id_,
	       cppvmString groupName, int groupId,
	       unsigned int keyLen_, float *key_);
  userKeyClass(const userKeyClass&);
  virtual ~userKeyClass();

// overloaded operators
  userKeyClass& operator=(const userKeyClass&);
  bool operator==(const userKeyClass&);
  bool operator==(const userKeyClass&) const;

// stream methods
  virtual void cppvmScanFrom(istream& = cin);
  virtual void cppvmPrintOn(ostream& = cout);

// transfer method
// used by send/receive/distributed/mailbox messages of this class
  virtual void cppvmTransfer();
    
// pvm message tag declaration
  CPPvmMethodsDeclarationVariable

public:
  int keyLen;
  float* key;
};

// receive function for collections
// normal c-function, not a method
cppvmObject*
userKeyClassRecColl(int classId);

#endif
