// cppvm 'hello world'
#include "cppvm.h"

int
main()
{
  // create default integer object
  cppvmInt cppvmIVal;
  cout << "cppvmIVal: " << cppvmIVal << endl;
  
  // create double object by using the copy constructor
  cppvmDouble cppvmDVal = 100.3;
  cout << "cppvmDVal: " << cppvmDVal << endl;
  
  // create float object
  cppvmFloat cppvmFVal(1.1);
  cout << "cppvmFVal 1: " << cppvmFVal << endl;
  
  // assign constant value to cppvm object
  cppvmFVal = 2.2;
  cout << "cppvmFVal 2: " << cppvmFVal << endl;
  
  // assign float value to cppvm object
  float fVal = 3.3;
  cppvmFVal = fVal;
  cout << "cppvmFVal 3: " << cppvmFVal << endl;
  
  // assign cppvm to standard type
  fVal = cppvmFVal;
  // or even better:
  fVal = (float) cppvmFVal;
  cout << "fVal 1: " << fVal << endl;
  
  // get pointer
  float *pFVal;
  pFVal = cppvmFVal.getPtr();
  
  // the following assignment sets also the cppvmFVal value
  (*pFVal) = 4.4;
  cout << "cppvmFVal 4: " << cppvmFVal << endl;

  // array of long values, length = 10
  cppvmArrayLong cppvmALVal(10);
  cout << "cppvmALVal 1: " << cppvmALVal << endl;
  
  // assign static value
  cppvmALVal[0] = 111;
  cout << "cppvmALVal 2: " << cppvmALVal << endl;
  
  // assign standard type
  long lVal = 222;
  cppvmALVal[1] = lVal;
  cout << "cppvmALVal 3: " << cppvmALVal << endl;
  
  // assign cppvm value to standard type
  lVal = cppvmALVal[1];
  cout << "lVal: " << lVal << endl;
  
  // get pointer to array
  long *pALVal;
  pALVal = cppvmALVal.getPtr();
  
  // the following assignment sets also one cppvmALVal value
  pALVal[2] = 333;
  cout << "cppvmALVal 4: " << cppvmALVal << endl;

  return 0;
}

