// cppvm 'send/rec/distributed of a new bool array class'

#include "cppvm.h"
#include "boolar.h"

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  int i;
  // object of new class
  boolArray baObj;

  // spawn child process 'ba2'
  cppvmSpawnConnection child("ba2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  baObj.cppvmDistObj("baObject");

  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    baObj.cppvmReadMboxInfo();
    cout << '\r' 
         << baObj;
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive message from child process
  recStrm >> baObj;
  
  cout << "received object: " 
       << baObj << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

