// usage of the CPPvm bool classes
#include "cppvm.h"

int
main()
{
  // spawn child process 'bool2'
  cppvmSpawnConnection child("bool2");
  // message passing descriptor
  cppvmReceiveStream recStrm(child, CPPvmRBchild);

  // bool array
  cppvmArrayBool boolArray;

  // receive bool array
  recStrm >> boolArray;
  cout << boolArray << endl;

  // append next array
  boolArray.setCPPvmTransferMode(CPPvmTransferModeAppend);
  recStrm >> boolArray;
  cout << boolArray << endl;

  cppvmBool ok;

  // receive bool
  recStrm >> ok;
  cout << "received ok from child: " 
       << ok << endl;

  // do some bool operations:
  bool val1=true;
  cppvmBool val2=false;

  cout << "val1: " << val1 
       << " val2: " << val2 
       << endl
       << "!val1: " << (!val1)
       << " !val2: " << (!val2) 
       << endl
       << "val1&&val2: " << (val1&&val2)
       << " val2&&val1: " << (val2&&val1) 
       << endl
       << "val1||val2: " << (val1||val2)
       << " val2||val1: " << (val2||val1)
       << endl;

  // halt the virtual machine
  child.halt();

  return 0;
}






