// cppvm 'catch world'
#include "cppvm.h"
// CPPVM_SLEEP define
#include "examplesdefines.h"

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  // catchout to stdout 
  cppvmCatchout catchout(CPPvmStdout);
  // spawn child process 'catch2'
  cppvmSpawnConnection firstChild("catch2");
  cout << catchout << endl;

  CPPVM_SLEEP(5);

  // every new cppvmCatchout object will
  // also redirect ALL previously
  // caught children output

  // catch output to file
  cppvmCatchout catchout2(CPPvmFile, "catch.out");
  // spawn child process 'catch2'
  cppvmSpawnConnection secondChild("catch2");
  cout << catchout2 << endl;

  CPPVM_SLEEP(5);

  // set the first catchout again
  catchout.reset();

  CPPVM_SLEEP(5);

  // halt the virtual machine
  pvmConn.halt();
  
  return 0;
}
