// cppvm 'connect two processes without spawn'
#include "cppvm.h"
// CPPVM_SLEEP define
#include "examplesdefines.h"

int
main()
{
  int i;

  // connect to pvm
  cppvmConnection pvmConn;

  // let 'conn2' time to connect to pvm
  CPPVM_SLEEP(5);

  // get information about the pvm configuration
  pvmConn.printHostInfo();

  // get informations about pvm tasks
  // pvmConn.printTaskInfo();
  int ntask;
  struct pvmtaskinfo *taskp;
  
  pvmConn.taskInfo(0, &ntask, &taskp);

  cout << "My task id: " << pvmConn.getTid()
       << endl << "Info about all pvm Tasks:"
       << endl;
  
  // print all pvm tasks
  for(i=0;i<ntask;i++){
    pvmConn.printOneTaskInfo(taskp[i]);
  }

  // integer object
  cppvmInt distInt(88);

  // send descriptor	  
  cppvmSendStream sendStrm;

  // send a integer to all other tasks
  for(i=0;i<ntask;i++){
    if((taskp[i].ti_tid)!= pvmConn.getTid()){
      // initialize send descriptor 
      // (nonblocking send to task)
      sendStrm.set((taskp[i].ti_tid), CPPvmSNBtid);
      
      // send object to other task
      sendStrm << distInt;
    }
  }

  // register the object as a distributed object
  distInt.cppvmDistObj("distIntKey");

  for(i=0;i<5000;i++){
    // update the local string with the value
    // in the message box
    distInt.read();
    cout << '\r' << distInt;
    cout.flush();
  }
  
  // receive descriptor	  
  // (blocking receive from any task)
  cppvmReceiveStream recStrm(CPPvmRBany);

  recStrm >> distInt;

  cout << endl << "received from other task: " << distInt << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

