// cppvm 'connect two processes without spawn'
#include "cppvm.h"

int
main()
{
  int i;

  // connect to pvm
  cppvmConnection pvmConn;

  cout << "My task id: " << pvmConn.getTid()
       << endl;

  // integer object
  cppvmInt distInt(0);

  // receive descriptor	  
  // (blocking receive from any task)
  cppvmReceiveStream recStrm(CPPvmRBany);

  recStrm >> distInt;

  cout << "conn2: received " << distInt
       << " from task with id: "
       << recStrm.getLastRecFromTid()
       << endl;
  
  // connect to message mailbox
  distInt.cppvmDistObj("distIntKey");

  for(i=0;i<5000; i++){
    // use write() to update distributed object
    distInt.write(i);
  }

  // send integer back
  distInt = 99;

  // send descriptor
  // blocking send back to other task
  cppvmSendStream sendStrm(recStrm, CPPvmSBback);

  // send message to other task
  sendStrm << distInt;

  return 0;
}


