#include "cppvm.h"

// global variables
cppvmConnection *pvmConn;

int minMsgSize, maxMsgSize, msgSizeStep, intMsgMode, initSend;
cppvmInt numMsg, msgMode, msgSize, route, msgEncoding;

cppvmSendStream      *notifySendStrm;
cppvmSendStream      *sendStrm;
cppvmSendStream      *handshakeSendStrm;
cppvmReceiveStream   *recStrm;
cppvmReceiveStream   *paramsRecStrm;
cppvmReceiveStream   *handshakeRecStrm;
cppvmArrayChar       *msg;
cppvmInt handshake;

void
initMeasurement()
{
  // send stream
  notifySendStrm = new cppvmSendStream((*pvmConn),CPPvmSNBparent);
  // receive stream
  paramsRecStrm = new cppvmReceiveStream((*pvmConn), CPPvmRBparent);

  // receive route and msgEncoding
  (*paramsRecStrm) >> route >> msgEncoding;

  // evaluate route
  if((int)route==1){
    // direct connection between two tasks
    pvmConn->setOpt(PvmRoute, PvmRouteDirect);
  }

  // evaluate msgEncoding
  if((int)msgEncoding==1){
    initSend = PvmDataInPlace;
  }
  else if((int)msgEncoding==2){
    initSend = PvmDataRaw;
  }
  else{
    initSend = PvmDataDefault;
  }

  // new array
  msg = new cppvmArrayChar(0);
  
  // receive some parameters
  (*paramsRecStrm) >> msgMode >> numMsg;
  intMsgMode = (int) msgMode;

  // evaluate msgMode
  if((int)msgMode==0){
    sendStrm = new cppvmSendStream((*pvmConn), CPPvmSNBparent, initSend);
    recStrm  = new cppvmReceiveStream((*pvmConn),  CPPvmRBparent);
  }
  else if((int)msgMode==1){
    sendStrm = new cppvmSendStream((*pvmConn), CPPvmSBparent, initSend);
    recStrm  = new cppvmReceiveStream((*pvmConn),  CPPvmRBparent);
  }
  else if((int)msgMode==2){
    handshakeSendStrm = new cppvmSendStream((*pvmConn), CPPvmSNBparent);
    handshakeRecStrm  = new cppvmReceiveStream((*pvmConn),  CPPvmRBparent);
    msg->cppvmDistObj("m");
  }
}

void
dataTransfer()
{
  if(intMsgMode==2){
    // wait for cppvmspeed to write data
    (*handshakeRecStrm) >> handshake;
    // write message to data base
    msg->cppvmWriteMboxInfo();
    // signal cppvmspeed to get message
    (*handshakeSendStrm) << handshake;
  }
  else{
    (*recStrm)   >> (*msg);
    (*sendStrm) << (*msg);
  }
}

void
measurement()
{
  int i;
  int loopNum = (int)numMsg;
  cppvmInt notify;
  
  while(1){
    // receive current message size 
    (*paramsRecStrm) >> msgSize;
    // set the current message size
    msg->resize((unsigned int)((int)msgSize));
    
    // send notification
    (*notifySendStrm) << notify;
    // begin transfer
    for(i=0;i<loopNum;i++){
      dataTransfer();
    }
  }
}

void
main2()
{
  // connect to pvm
  pvmConn = new cppvmConnection();

  initMeasurement();
  
  measurement();
}

int
main()
{
  // catch all possible exceptions
  CPPvmTryAll(main2())
  return 0;
}
