// cppvm 'distributed hello world'
#include "cppvm.h"

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  // string object
  cppvmString distStr("Hello parent process!");
  // register the object as a distributed object
  distStr.cppvmDistObj("distributedHelloMsg");

  cout << "Hello child process!" << endl;

  // direct all couts to stdout
  cppvmCatchout catchOut(CPPvmStdout);
  // spawn child process 'dhello2'
  cppvmSpawnConnection child("dhello2");

  // distributed strings can still be received
  cppvmReceiveStream recStrm(child, CPPvmRBchild);

  recStrm >> distStr;
  cout << distStr << endl;
  
  // halt the virtual machine
  pvmConn.halt();

  return 0;
}
