// cppvm 'distributed integer object'
#include "cppvm.h"

int
main()
{
  int i;

  // connect to pvm
  cppvmConnection pvmConn;

  // spawn child process 'distint2'
  cppvmSpawnConnection child("distint2");

  // integer object
  cppvmInt distInt(0);
  // register the object as a distributed object
  distInt.cppvmDistObj("uniqueKeyNameForThisDistIntObj");

  for(i=0;i<1000;i++){
    // update the local integer with the value
    // in the message box
    distInt.read();
    cout << '\r' << distInt;
    cout.flush();
  }

  // the distributed object can still be used
  // to be sent/received

  // receive descriptor	  
  // (blocking receive from child process)
  cppvmReceiveStream recStrm(child, CPPvmRBchild);

  recStrm >> distInt;

  cout << endl << "received from child: " << distInt << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

