// cppvm 'distributed string object'
#include "cppvm.h"

int
main()
{
  int i;
  
  // connect to pvm
  cppvmConnection pvmConn;

  // spawn child process 'diststr2'
  cppvmSpawnConnection child("diststr2");

  // spawn child on 'myhost' using pvm debugging
  //cppvmSpawnConnection child("diststr2", "", 
  //                           PvmTaskHost+PvmTaskDebug, "myhost");

  // string object
  cppvmString distStr("");
  // register the object as 
  // a distributed object
  // with key name "scrollText"
  distStr.cppvmDistObj("scrollText");

  for(i=0;i<500;i++){
    // update the local string 
    // with the value
    // in the message box
    distStr.cppvmReadMboxInfo();
    cout << '\r' << distStr;
    cout.flush(); 
  }
  
  // every object with 'cppvmObject' as parent
  // class has the methods 'read()' and 'write()'
  // (except for your own written classes)
  // they get/set the value of the object
  // if an object is a distributed object, the
  // value is updated with the message box object 
  for(i=0;i<500;i++){
    // update the local string with the value
    // in the message box
    cout << '\r' << distStr.read();
    cout.flush();
  }
  
  // the distributed object can 
  // still be used for 
  // explicit message passing

  // receive descriptor	  
  // (blocking receive from 
  // child process)
  cppvmReceiveStream recStrm(child, CPPvmRBchild);

  recStrm >> distStr;

  cout << endl << "received from child: " << distStr << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}
