#include "cppvm.h"
// external class
#include "point.h"
// CPPvm wrapper class
#include "cppvmpoint.h"
// mulitple inheritance class
#include "cppvmderivedpoint.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmPoint p;
  cppvmDerivedPoint dp;
  vector<point> vectP;

  cout << "distributed object..." << endl;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the objects 
  // as a distributed objects
  p.cppvmDistObj("point");
  dp.cppvmDistObj("derivedPoint");

  int i;
  for(i=0;i<500;i++){
    // update message mailbox
    p.value.x = i;
    p.cppvmWriteMboxInfo();
    dp.x = i;
    dp.cppvmWriteMboxInfo();
  }

  cout << "send objects..." << endl;

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                           CPPvmSBparent);
  // set new values
  p.value.x = 4;
  p.value.y = 5;
  dp.x = 6;
  dp.y = 7;
  vectP.resize(5);
  i=0;
  vector<point>::iterator j;
  for (j=vectP.begin(); j != vectP.end() ; j++) {
    j->x=i;
    j->y=i+1;
    i=i+2;
  }

  // send objects to parent process
  sendStrm << p << dp << vectP;

  return 0;
}
