// cppvm 'gimme5'

#include "cppvm.h"

void
gimme5(void)
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmString recStr("");
  cppvmString resStr("5!");
  cppvmSendStream sendStrm;  

  // blocking receive from any process
  cppvmReceiveStream recStrm(CPPvmRBany);

  // endless cycle
  while(1){
    // blocking wait until a message arrives
    recStrm >> recStr;
    // send a message back to the sender
    sendStrm.set(recStrm, CPPvmSNBback);

    sendStrm << resStr;

    ///////////////////////////////////////////////////
    // uncomment the next line to cause an exception //
    //cppvmString((char*) NULL);
    ///////////////////////////////////////////////////
  }
}

void errorHandling(void){
  // an exception occurred
  cppvmConnection pvmConn;
  // fill distributed error message
  // distributed objects are not restricted to contexts
  cppvmString errStr("");
  errStr.cppvmDistObj("exception error message");
  errStr.write("exception occurred in gimme5");
  // signal exception to administrator
  cppvmInt indicateError;
  indicateError.cppvmDistObj("error notify");
  // set error notifier
  indicateError.write(1);
  // endless wait (until admin has
  // killed all processes)
  int counter=0;
  while(1){
    counter++;
  }
}

int
main(){
  try {
    gimme5();
  }
  catch (cppvmException& exception) {                      
    cerr << exception;                                   
    errorHandling();
  }
  catch (...) {
    cerr << "exception occurred (not part of cppvm)" << endl;
    errorHandling();
  }
  return 0;
}
