#include "cppvm.h"
// external class
#include "hiddenpoint.h"
// CPPvm wrapper classes
#include "cppvmhiddenpoint.h"
#include "cppvmanotherhiddenpoint.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmHiddenPoint p;
  cppvmAnotherHiddenPoint ap;
  vector<hiddenPoint> vectP;

  cout << "distributed object..." << endl;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the objects 
  // as a distributed objects
  p.cppvmDistObj("p");
  ap.cppvmDistObj("ap");

  int i;
  for(i=0;i<500;i++){
    // update message mailbox
    p.value.setX(i);
    p.cppvmWriteMboxInfo();
    ap.value.setX(i);
    ap.cppvmWriteMboxInfo();
  }

  cout << "send objects..." << endl;

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                           CPPvmSBparent,
                           PvmDataInPlace);
  // set new values
  p.value.setX(4);
  p.value.setY(5);
  ap.value.setX(6);
  ap.value.setY(7);
  vectP.resize(5);
  i=0;
  vector<hiddenPoint>::iterator j;
  for (j=vectP.begin(); j != vectP.end() ; j++) {
    j->setX(i);
    j->setY(i+1);
    i=i+2;
  }
  
  // send objects to parent process
  sendStrm << p << ap << vectP;

  return 0;
}

