// hiddenPoint
// NO CPPvm class!

// include specification file
#include "hiddenpoint.h"

// default constructor
hiddenPoint::hiddenPoint()
{
  x=0;
  y=0;
}

// transfer function for aggregated 'hiddenPoint' objects
void
cppvmTransferHiddenPoint(hiddenPoint* data, int nitem, int stride)
{
  int i;
  for(i=0; i<nitem; i++){
    if(cppvmIsTransferSend()==true){
      cppvmNewSendStackData<cppvmInt> array(2);
      array.data[0] = data[i].getX();
      array.data[1] = data[i].getY();
      array.data[0].cppvmTransfer();
      array.data[1].cppvmTransfer();
    }
    else{
      cppvmInt x;
      cppvmInt y;
      x.cppvmTransfer();
      y.cppvmTransfer();
      data[i].setX((int)x);
      data[i].setY((int)y);
    }
  }
}

// specialized template functions
template<>
void
cppvmTransferTemplate(hiddenPoint* data, int nitem, int stride)
{
  int i;
  for (i=0; i<nitem ; i++) {
    cppvmTransferTemplate( data[i], stride);
  }
}

template<>
void
cppvmTransferTemplate(hiddenPoint& data, int stride)
{
  if(cppvmIsTransferSend()==true){
    cppvmNewSendStackData<int> tmpIntArr(2);
    tmpIntArr.data[0] = data.getX();
    tmpIntArr.data[1] = data.getY();
    cppvmTransferInt(tmpIntArr.data, 2, stride);
  }
  else{
    int tmpIntArr[2];
    cppvmTransferInt(tmpIntArr,2, stride);
    data.setX(tmpIntArr[0]);
    data.setY(tmpIntArr[1]);
  }
}



