// cppvm 'message mailbox'
#include "cppvm.h"

int
main2()
{
  int i;
  int counter=0;
  int nclasses;
  struct pvmmboxinfo *classes;
  cppvmString mboxStr("");

  // connect process to pvm
  cppvmConnection pvmConn;

  // spawn child process 'mbox2'
  cppvmSpawnConnection child("mbox2");

  // use message box object for read only
  // read and delete the object in the
  // message mail box
  mboxStr.cppvmSetMboxRead("uniqueKeyName",
                         PvmMboxDefault+PvmMboxReadAndDelete);

  // wait until global debug level is
  // set to a value != 0
  while(child.getDebugLevel()==0){
    counter++;
  }

  cout << "debugLevel: "
       << child.getDebugLevel()
       << endl;

  // read all message box entries
  pvmConn.cppvmGetMboxInfo("*",
                      &nclasses,
                      &classes);
  for(i=0; i< nclasses; i++){
    cout << "mbox member: " << i << " name: "
         << classes[i].mi_name
         << " entries: "
         << classes[i].mi_nentries
         << endl;
  }
	
  // read and delete object
  mboxStr.cppvmReadMboxInfo();
  cout << "error message: " << mboxStr << endl;
  
  // read all message box entries again
  pvmConn.cppvmGetMboxInfo("*",
                      &nclasses,
                      &classes);
  for(i=0; i< nclasses; i++){
    cout << "mbox member: " << i << " name: "
         << classes[i].mi_name
         << " entries: "
         << classes[i].mi_nentries
         << endl;
  }

  cppvmString sendStr("You are out!");
  cppvmSendStream sendStrm(child, CPPvmSBchild);
  
  sendStrm << sendStr;
  
  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

int main()
{
  CPPvmTryAll(main2())

  return 0;
  
}

