#include "cppvm.h"

int
main()
{
  // double array object
  cppvmArrayDouble douArrObj(5);

  // connect to pvm
  cppvmConnection pvmConn;

  // receive descriptor
  cppvmReceiveStream recStrm;

  // add this process to a specific group
  // this is needed for receive from group broadcast
  // not for multicast
  pvmConn.joinGroup("my group name");

  ////////////////////////////
  // receive from multicast //
  ////////////////////////////

  // blocking receive from parent
  recStrm.set(pvmConn, CPPvmRBparent);
  
  // receive object from parent process
  cout << "array before first receive: " 
       << douArrObj << endl;
  // the received collection replaces the current collection
  recStrm >> douArrObj;
  cout << "After first receive: " 
       << douArrObj << endl;

  // the received collection is appended to the current collection
  douArrObj.setCPPvmTransferMode(CPPvmTransferModeAppend);
  recStrm >> douArrObj;
  cout << "After second receive: " 
       << douArrObj << endl;

  //////////////////////////////////
  // receive from group broadcast //
  //////////////////////////////////

  // string object
  cppvmString stringObj("What message will a group member send me?");

  cout << stringObj << endl;
  recStrm >> stringObj;
  cout << stringObj << endl;

  stringObj = "Ready!";
  // send descriptor
  cppvmSendStream sendStrm(pvmConn, CPPvmSBparent);
  sendStrm << stringObj;
  
  return 0;
}
