// mutex concept using functions
# include "cppvm.h"

// counter
cppvmInt countVar;

void
incCounter()
{
  countVar.cppvmReadMboxInfo();
  countVar++;
  countVar.cppvmWriteMboxInfo();
}

int
main()
{
  int i;

  // let pvm choose the host
  cppvmSpawnConnection child("mutexfunction2");

  // register the object 
  // as distributed object
  countVar.cppvmDistObj("counter");

  for(i=0; i< 3000; i++){
    // call the function 'incCounter'
    // encapsulated by the standard 
    // semaphore variable
    cppvmMutex(incCounter);

    // The version without "cppvmMutex" 
    // can cause lost updates! Try the 
    // next call instead of the 
    // 'cppvmMutex' to see the 
    // difference
    //incCounter();

    cout << '\r' 
         << countVar;
    cout.flush();
  }
  
  // halt the virtual machine
  child.halt();

  return 0;
}


