// mutex concept using objects
#include "mutexobject.h"
#include <unistd.h>

int
main()
{
  int i;
  int value;
  
  // let pvm choose the host
  cppvmSpawnConnection child("mutexobject2");

  // wrapper object
  distObjWrapper dow(true);

  for(i=0; i< 3000; i++){
    // call the 'operator()' 
    // for the object 'dow'
    // encapsulated by a 
    // semaphore variable with
    // name 'dowMutex'
    cppvmMutex(dow, value, "dowMutex");
    
    // The version without 
    // 'cppvmMutex' can cause 
    // lost updates! Try the next
    // call instead of the 
    // 'cppvmMutex' call to see 
    // the difference
    //value = dow();
    
    cout << '\r' 
         << value;
    cout.flush();
  }
  
  // halt the virtual machine
  child.halt();

  return 0;
}

