#include "cppvm.h"
// include own classes 'userClass' and 'userKeyClass'
#include "user.h"
#include "userkey.h"

#define KEY_LEN 5

int
main()
{
  int i;

  // key for 'userKeyClass' objects
  float key [KEY_LEN];
  // fill key
  for(i=0; i<KEY_LEN; i++){
    key[i] = (float)i * 1.1;
  }

  // connect to pvm
  cppvmConnection pvmConn;

  // object of own class
  userClass user("einstein", 1, "physicist", 7);
  userKeyClass userKey("kant", 2, "philosopher", 8, KEY_LEN, key);

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send to parent process)
  cppvmSendStream sendStrm(pvmConn, CPPvmSBparent);
  
  // send objects to parent process
  sendStrm << user << userKey;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the objects as a distributed objects
  user.cppvmDistObj("userObject");
  userKey.cppvmDistObj("userKeyObject");

  for(i=0;i<500;i++){
    // update message box
    user.id = i;
    user.cppvmWriteMboxInfo();
    userKey.id = i;
    userKey.cppvmWriteMboxInfo();
  }

  /////////////////////////
  // nested collection   //
  /////////////////////////
  
  // collection for objects of 
  // 'cppvmObject' and derived classes
  cppvmObjectCollection myColl;

  // add some objects to the collection
  myColl.add(new userClass("chapman", 100, "monty python", 1));
  myColl.add(new userKeyClass("cleese", 101, "monty python", 1, KEY_LEN, key));
  
  // second collection
  cppvmObjectCollection *myColl2Ptr = new cppvmObjectCollection;
  myColl2Ptr->add(new 
    userKeyClass("gilliam", 102, "monty python", 1, KEY_LEN, key));
  myColl2Ptr->add(new userClass("idle", 103, "monty python", 1));

  // third collection
  cppvmObjectCollection *myColl3Ptr = new cppvmObjectCollection;
  myColl3Ptr->add(new 
    userKeyClass("jones", 104, "monty python", 1, KEY_LEN, key));

  // add collection 3 to collection 2
  myColl2Ptr->add(myColl3Ptr);
  // add collection 2 to collection 1
  myColl.add(myColl2Ptr);
  // add another object to collection 1
  myColl.add(new userKeyClass("palin", 105, "monty python", 1, KEY_LEN, key));

  /////////////////////////
  // collection send     //
  /////////////////////////

  // send object to parent process
  sendStrm << myColl;

  return 0;
}
