// cppvm 'newtag'
#include "cppvm.h"
// sleep
#include "examplesdefines.h"

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  // send/receive objects
  cppvmString stringObj;

  // spawn child process 'newtag2'
  cppvmSpawnConnection child("newtag2");

  // message passing descriptor
  // (blocking receive from child process)
  cppvmReceiveStream recStrm(child, CPPvmRBchild);

  recStrm >> stringObj;
  cout << "newtag: received string: "
       << stringObj << endl;

  // initialize receive descriptor 
  // (2.2 sec timeout
  // receive from child process)
  recStrm.set(child, CPPvmRTchild, 2, 200000);
  
  recStrm >> stringObj;
  
  if(recStrm.received()==false){
    cout << "newtag: could not get the message" << endl;
  }

  cout << "Tried to receive string message with tag: "
       << stringObj.cppvmMsgTag() << endl;
  int msgTag;
  recStrm.probeAny(msgTag);
  cout << "Message tag of current message in receive buffer: "
       << msgTag << endl;

  // set string message tag to this
  // message tag
  // the message tag is changed for
  // ALL cppvmString objects!!!
  cppvmString::setCPPvmClassMsgTag(msgTag);

  // blocking receive from child process
  recStrm.set(child, CPPvmRBchild);
  recStrm >> stringObj;

  cout << "newtag: got a message: "
       << stringObj << endl;

  // wait for message
  CPPVM_SLEEP(2);
  
  recStrm.probeAny(msgTag);
  cout << "Message tag of current message in receive buffer: "
       << msgTag << endl;
  
  // set string message tag to this
  // message tag
  // the message tag is changed only for
  // 'stringObj'
  stringObj.setCPPvmObjectMsgTag(msgTag);

  cout << "cppvmString class message tag: "
       << cppvmString::cppvmClassMsgTag() << endl;
  cout << "message tag of the 'stringObj' object: "
       << stringObj.cppvmMsgTag() << endl;

  recStrm >> stringObj;

  cout << "newtag: got another message: "
       << stringObj << endl;

  // halt the virtual machine
  child.halt();

  return 0;
}
