// stl wrapper class example

#include "cppvm.h"
// include new template class 'paramVector'
#include "paramvector.h"

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  paramVector<int> parVec;

  // catchout to stdout 
  cppvmCatchout catchout(CPPvmStdout);
  // spawn child process 'pavec2'
  cppvmSpawnConnection child("pavec2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  parVec.cppvmDistObj("parVecObject");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    parVec.cppvmReadMboxInfo();
    cout << '\r' ;
    parVec.print();
    cout.flush(); 
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive message from child process
  recStrm >> parVec;
  
  cout << "received object: ";
  parVec.print();
  cout << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

