#include "cppvm.h"
// include stl wrapper class 'paramVector'
#include "paramvector.h"

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  paramVector<int> parVec;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  parVec.cppvmDistObj("parVecObject");

  parVec.name = "demo vector";
  parVec.params.resize(3);

  int i;
  for(i=0;i<500;i++){
    // update message mailbox
    parVec.params[0] = i;
    parVec.cppvmWriteMboxInfo();
  }

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                      CPPvmSBparent);
  
  parVec.name = "that's it!";
  parVec.params[0]=111;
  parVec.params[1]=222;
  parVec.params[2]=333;
  // send object to parent process
  sendStrm << parVec;

  return 0;
}

