#include "cppvm.h"

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  // direct all couts of the
  // children to stdout
  cppvmCatchout catchOut(CPPvmStdout);

  // spawn child 'paul' on 'sun1'
  //cppvmSpawnConnection child("paul", "", 
  //  PvmTaskHost, "sun1");

  // let pvm choose the host
  cppvmSpawnConnection child("paul");
  
  // receive descriptor   
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
    CPPvmRBchild);

  // empty task description
  cppvmTask taskDesc;

  // receive task description
  recStrm >> taskDesc;

  // send descriptor
  // (blocking send 
  //  to task)
  cppvmSendStream sendStrm(taskDesc, 
    CPPvmSBtask);
  
  // message
  cppvmString sendMsg("hello mary!");

  // send message 
  sendStrm << sendMsg;

  return 0;
}

