// cppvm producer/consumer example
#include "cppvm.h"
#include "warehouse.h"

int
main()
{
  int i;
  
  // connect to pvm
  cppvmConnection pvmConn;

  // semaphore
  cppvmSemaphore ready("ready");
  ready.setNumber(0);

  // warehouse
  warehouse room;
  // 7 object can be stored
  room.init(7);

  // catchout to stdout 
  cppvmCatchout catchout(CPPvmStdout);
  // spawn child process 'consumer'
  cppvmSpawnConnection child("consumer");

  // produce 10 objects
  for(i=0; i<10; i++){
    room.put();
  }
  
  // wait for consumer
  ready.enter();
  // resize storage room
  room.resize(4);
  // release consumer
  ready.leave();
  
  // produce 10 objects
  for(i=0; i<10; i++){
    room.put();
  }

  // wait for consumer
  ready.enter();
  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

