// stl bitset class: cppvm send/rec/distributed 

#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlBitset<5> bCppvm;
  bitset<10> b;

  // spawn child process, redirect output
  cppvmCatchout catchOut(CPPvmStdout);
  cppvmSpawnConnection child("stlbitset2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  bCppvm.cppvmDistObj("bitset");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    bCppvm.cppvmReadMboxInfo();
    cout << '\r';
    cout << bCppvm;
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive data from child process
  recStrm >> bCppvm >> b;
  
  cout << "received objects: " ;
  cout << bCppvm;
  cout << " and: ";
  cout << b;
  cout << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

