#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;
  string initBCppvm = "10101";
  string initB = "1010101010";
  

  cppvmStlBitset<5> bCppvm(initBCppvm);
  bitset<10> b(initB);

  cout << "distributed object..." << endl;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  bCppvm.cppvmDistObj("bitset");

  unsigned int i;
  unsigned int j;
  unsigned int pos=0;
  for(i=0;i<500;i++){
    for(j=0;j<bCppvm.size(); j++){
      bCppvm.set(j,0);
    }
    bCppvm.set(pos,1);
    bCppvm.cppvmWriteMboxInfo();

    pos++;
    if(pos==bCppvm.size()){
      pos=0;
    }
  }

  cout << "send objects..." << endl;

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                           CPPvmSBparent);
  
  // fill bitsets
  for(i=0;i<bCppvm.size(); i++){
    bCppvm.set(i,0);
  }
  for(i=0;i<b.size(); i++){
    b.set(i,1);
  }
  
  // send objects to parent process
  sendStrm << bCppvm << b;

  return 0;
}




