// stl complex class: cppvm send/rec/distributed 

#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlComplex<float> compCppvm(1.1,2.2);
  complex<float> comp(3.3,4.4);

  // spawn child process, redirect output
  cppvmCatchout catchOut(CPPvmStdout);
  cppvmSpawnConnection child("stlcomplex2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  compCppvm.cppvmDistObj("complex");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    compCppvm.cppvmReadMboxInfo();
    cout << '\r' 
         << compCppvm;
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive data from child process
  recStrm >> compCppvm >> comp;
  
  cout << "received objects: " 
       << compCppvm << " and: "
       << comp << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

