#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlComplex<float> compCppvm;
  complex<float> comp(8.8,9.9);

  cout << "distributed object..." << endl;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  compCppvm.cppvmDistObj("complex");

  int i;
  for(i=0;i<500;i++){
    // update message mailbox
    compCppvm = complex<float>(compCppvm.real(), i);
    compCppvm.cppvmWriteMboxInfo();
  }


  cout << "send objects..." << endl;

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                           CPPvmSBparent);
  
  compCppvm = complex<float>(0.1, 0.2);
  
  // send objects to parent process
  sendStrm << compCppvm << comp;

  return 0;
}
