// stl deque class: cppvm send/rec/distributed 

#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

void printDeque(deque<double>& data)
{
  deque<double>::iterator i;
  for (i=data.begin(); i != data.end() ; i++) {
    cout << *i << " ";
  }
}

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlDeque<double> deqCppvm;
  deque<double> deq;

  // spawn child process, 
  // redirect output
  cppvmCatchout catchOut(CPPvmStdout);
  cppvmSpawnConnection child("stldeque2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  deqCppvm.cppvmDistObj("deque");

  int i;
  for(i=0;i<500;i++){
    // update the local value 
    // with the value
    // in the message box
    deqCppvm.cppvmReadMboxInfo();
    cout << '\r';
    printDeque(deqCppvm);
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive data from child process
  recStrm >> deqCppvm >> deq;
  
  cout << "received objects: " ;
  printDeque(deqCppvm);
  cout << " and: ";
  printDeque(deq);
  cout << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

