#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlDeque<double> deqCppvm;
  deque<double> deq(3);

  cout << "distributed object..." << endl;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  deqCppvm.cppvmDistObj("deque");

  deqCppvm.resize(7);
  int i;
  for(i=0;i<500;i++){
    // update message mailbox
    deqCppvm[0] = i;
    deqCppvm.cppvmWriteMboxInfo();
  }

  cout << "send objects..." << endl;

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                           CPPvmSBparent);
  
  // fill deques
  for(i=0;i<3;i++){
    deq[i] = i;
  }
  deqCppvm.resize(5);
  for(i=0;i<5;i++){
    deqCppvm[i] = i+1;
  }
  
  // send objects to 
  // parent process
  sendStrm << deqCppvm << deq;

  return 0;
}
