// stl list class: cppvm send/rec/distributed 

#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

void printList(list<int>& data)
{
  list<int>::iterator i;
  for (i=data.begin(); i != data.end() ; i++) {
    cout << *i << " ";
  }
}

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlList<int> lCppvm;
  list<int> l;

  // spawn child process, redirect output
  cppvmCatchout catchOut(CPPvmStdout);
  cppvmSpawnConnection child("stllist2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  lCppvm.cppvmDistObj("list");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    lCppvm.cppvmReadMboxInfo();
    cout << '\r';
    printList(lCppvm);
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive data from child process
  recStrm >> lCppvm >> l;
  
  cout << "received objects: " ;
  printList(lCppvm);
  cout << " and: ";
  printList(l);
  cout << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

