#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlList<int> lCppvm;
  list<int> l;

  cout << "distributed object..." << endl;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  lCppvm.cppvmDistObj("list");

  lCppvm.resize(7);
  int i;
  list<int>::iterator j;
  j=lCppvm.begin();
  for(i=0;i<500;i++){
    // update message mailbox
    *j = i;
    lCppvm.cppvmWriteMboxInfo();
  }

  cout << "send objects..." << endl;

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                           CPPvmSBparent);
  
  // fill lists
  lCppvm.resize(0);
  for(i=0;i<5;i++){
    lCppvm.push_back(i);
  }
  l.resize(0);
  for(i=0;i<3;i++){
    l.push_front(i);
  }
  
  // send objects to parent process
  sendStrm << lCppvm << l;

  return 0;
}
