// stl map class: cppvm send/rec/distributed 

#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

void printMap(map<int,string>& data)
{
  map<int,string>::iterator i;
  for (i=data.begin(); i != data.end() ; i++) {
    cout << "ranking: " << i->first << " ";
    cout << "player: " << i->second << " ";
  }
}
  
  

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlMap<int,string> mCppvm;
  map<int,string> m;

  // spawn child process, redirect output
  cppvmCatchout catchOut(CPPvmStdout);
  cppvmSpawnConnection child("stlmap2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  mCppvm.cppvmDistObj("map");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    mCppvm.cppvmReadMboxInfo();
    cout << '\r';
    printMap(mCppvm);
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive data from child process
  recStrm >> mCppvm >> m;
  
  cout << "received objects: " ;
  printMap(mCppvm);
  cout << endl << " and: " << endl;
  printMap(m);
  cout << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

