#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlMap<int,string> mCppvm;
  map<int,string> m;

  cout << "distributed object..." << endl;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  mCppvm.cppvmDistObj("map");

  int i;
  for(i=0;i<500;i++){
    // update message mailbox
    mCppvm.clear();
    mCppvm.insert(map<int,string>::value_type (i,"Beckenbauer"));
    mCppvm.cppvmWriteMboxInfo();
  }

  cout << "send objects..." << endl;

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                           CPPvmSBparent);
  
  // fill maps
  m.insert(map<int,string>::value_type (1,"Pele"));
  mCppvm.clear();
  mCppvm.insert(map<int,string>::value_type (3,"Beckenbauer"));
  mCppvm.insert(map<int,string>::value_type (2,"Cruyff"));
  mCppvm.insert(map<int,string>::value_type (1,"Pele"));

  // send objects to parent process
  sendStrm << mCppvm << m;

  return 0;
}
