// stl multimap class: cppvm send/rec/distributed 

#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

void printMultimap(multimap<int,string>& data)
{
  multimap<int,string>::iterator i;
  for (i=data.begin(); i != data.end() ; i++) {
    cout << "ranking: " << i->first << " ";
    cout << "player: " << i->second << " ";
  }
}

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlMultimap<int,string> mmCppvm;
  multimap<int,string> mm;

  // spawn child process, redirect output
  cppvmCatchout catchOut(CPPvmStdout);
  cppvmSpawnConnection child("stlmultimap2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  mmCppvm.cppvmDistObj("multimap");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    mmCppvm.cppvmReadMboxInfo();
    cout << '\r';
    printMultimap(mmCppvm);
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive data from child process
  recStrm >> mmCppvm >> mm;
  
  cout << "received objects: " ;
  printMultimap(mmCppvm);
  cout << endl << " and: " << endl;
  printMultimap(mm);
  cout << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

