#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlMultimap<int,string> mmCppvm;
  multimap<int,string> mm;

  cout << "distributed object..." << endl;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  mmCppvm.cppvmDistObj("multimap");

  int i;
  for(i=0;i<500;i++){
    // update message mailbox
    mmCppvm.clear();
    mmCppvm.insert(multimap<int,string>::value_type (i,"Beckenbauer"));
    mmCppvm.cppvmWriteMboxInfo();
  }

  cout << "send objects..." << endl;

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                           CPPvmSBparent);
  
  // fill multimaps
  mm.insert(multimap<int,string>::value_type (1, "Pele"));
  mmCppvm.clear();
  mmCppvm.insert(multimap<int,string>::value_type (1,"Pele"));
  mmCppvm.insert(multimap<int,string>::value_type (1,"Pele"));
  mmCppvm.insert(multimap<int,string>::value_type (1,"Pele"));
  
  // send objects to parent process
  sendStrm << mmCppvm << mm;

  return 0;
}
