// stl multiset class: cppvm send/rec/distributed 

#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

void printMultiset(multiset<int>& data)
{
  multiset<int>::iterator i;
  for (i=data.begin(); i != data.end() ; i++) {
    cout << *i << " ";
  }
}
  
  

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlMultiset<int> msCppvm;
  multiset<int> ms;

  // spawn child process, redirect output
  cppvmCatchout catchOut(CPPvmStdout);
  cppvmSpawnConnection child("stlmultiset2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  msCppvm.cppvmDistObj("multiset");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    msCppvm.cppvmReadMboxInfo();
    cout << '\r';
    printMultiset(msCppvm);
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive data from child process
  recStrm >> msCppvm >> ms;
  
  cout << "received objects: " ;
  printMultiset(msCppvm);
  cout << " and: ";
  printMultiset(ms);
  cout << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

