#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlMultiset<int> msCppvm;
  multiset<int> ms;

  cout << "distributed object..." << endl;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  msCppvm.cppvmDistObj("multiset");

  int i;
  for(i=0;i<500;i++){
    // update message mailbox
    msCppvm.clear();
    msCppvm.insert(i);
    msCppvm.cppvmWriteMboxInfo();
  }

  cout << "send objects..." << endl;

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                           CPPvmSBparent);
  
  // fill multisets
  for(i=0;i<3;i++){
    ms.insert(9);
  }
  msCppvm.clear();
  for(i=0;i<5;i++){
    msCppvm.insert(i+1);
  }
  
  // send objects to parent process
  sendStrm << msCppvm << ms;

  return 0;
}
