// stl pair class: cppvm send/rec/distributed 

#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

void printPair(pair<int,string>& data)
{
  cout << "first: " << data.first
       << " second: " << data.second;
}
  
  

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlPair<int,string> pCppvm;
  pair<int,string> p;

  // spawn child process, redirect output
  cppvmCatchout catchOut(CPPvmStdout);
  cppvmSpawnConnection child("stlpair2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  pCppvm.cppvmDistObj("pair");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    pCppvm.cppvmReadMboxInfo();
    cout << '\r';
    printPair(pCppvm);
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive data from child process
  recStrm >> pCppvm >> p;
  
  cout << "received objects: " ;
  printPair(pCppvm);
  cout << endl << " and: " << endl;
  printPair(p);
  cout << endl;
  
  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

