#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlPair<int,string> pCppvm;
  pair<int,string> p;

  cout << "distributed object..." << endl;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  pCppvm.cppvmDistObj("pair");

  int i;
  for(i=0;i<500;i++){
    // update message mailbox
    pCppvm.first = i;
    pCppvm.second = "Beckenbauer";
    pCppvm.cppvmWriteMboxInfo();
  }

  cout << "send objects..." << endl;

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                           CPPvmSBparent);
  
  // fill pairs
  pCppvm.first = 1;
  pCppvm.second = "Pele";
  p.first = 2;
  p.second = "Cruyff";

  // send objects to parent process
  sendStrm << pCppvm << p;

  return 0;
}
