// stl priority_queue class: cppvm send/rec/distributed 

#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif
#endif

void printPriorityqueue(priority_queue<int>& data)
{
  while(data.size()>0){
    cout << data.top() << " ";
    data.pop();
  }
}

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlPriorityqueue<int> queCppvm;
  priority_queue<int> que;

  // spawn child process, redirect output
  cppvmCatchout catchOut(CPPvmStdout);
  cppvmSpawnConnection child("stlpriorityqueue2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  queCppvm.cppvmDistObj("priorityqueue");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    queCppvm.cppvmReadMboxInfo();
    cout << '\r';
    printPriorityqueue(queCppvm);
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive data from child process
  recStrm >> queCppvm;
  recStrm >> que;
  
  cout << "received objects: " ;
  printPriorityqueue(queCppvm);
  cout << " and: ";
  printPriorityqueue(que);
  cout << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

