#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlQueue<int> queCppvm;
  queue<int> que;

  cout << "distributed object..." << endl;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  queCppvm.cppvmDistObj("queue");

  int i;
  for(i=0;i<500;i++){
    // update message mailbox
    queCppvm.push(i);
    queCppvm.cppvmWriteMboxInfo();
    queCppvm.pop();
  }

  cout << "send objects..." << endl;

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                           CPPvmSBparent);
  
  // fill queues
  for(i=0;i<3;i++){
    que.push(i);
  }
  for(i=0;i<5;i++){
    queCppvm.push(i);
  }
  
  // send objects to parent process
  sendStrm << queCppvm << que;

  return 0;
}
