// stl set class: cppvm send/rec/distributed 

#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

void printSet(set<int>& data)
{
  set<int>::iterator i;
  for (i=data.begin(); i != data.end() ; i++) {
    cout << *i << " ";
  }
}
  
  

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlSet<int> sCppvm;
  set<int> s;

  // spawn child process, redirect output
  cppvmCatchout catchOut(CPPvmStdout);
  cppvmSpawnConnection child("stlset2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  sCppvm.cppvmDistObj("set");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    sCppvm.cppvmReadMboxInfo();
    cout << '\r';
    printSet(sCppvm);
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive data from child process
  recStrm >> sCppvm >> s;
  
  cout << "received objects: " ;
  printSet(sCppvm);
  cout << " and: ";
  printSet(s);
  cout << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

