#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlSet<int> sCppvm;
  set<int> s;

  cout << "distributed object..." << endl;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  sCppvm.cppvmDistObj("set");

  int i;
  for(i=0;i<500;i++){
    // update message mailbox
    sCppvm.clear();
    sCppvm.insert(i);
    sCppvm.cppvmWriteMboxInfo();
  }

  cout << "send objects..." << endl;

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                           CPPvmSBparent);
  
  // fill sets
  for(i=0;i<3;i++){
    s.insert(i);
  }
  sCppvm.clear();
  for(i=0;i<5;i++){
    sCppvm.insert(i+1);
  }
  
  // send objects to parent process
  sendStrm << sCppvm << s;

  return 0;
}
