// stl slist class: cppvm send/rec/distributed 

#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

void printSlist(slist<int>& data)
{
  slist<int>::iterator i;
  for (i=data.begin(); i != data.end() ; i++) {
    cout << *i << " ";
  }
}
  
  

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlSlist<int> slCppvm;
  slist<int> sl;

  // spawn child process, redirect output
  cppvmCatchout catchOut(CPPvmStdout);
  cppvmSpawnConnection child("stlslist2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  slCppvm.cppvmDistObj("slist");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    slCppvm.cppvmReadMboxInfo();
    cout << '\r';
    printSlist(slCppvm);
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive data from child process
  recStrm >> slCppvm >> sl;
  
  cout << "received objects: " ;
  printSlist(slCppvm);
  cout << " and: ";
  printSlist(sl);
  cout << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

