#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlSlist<int> slCppvm;
  slist<int> sl;

  cout << "distributed object..." << endl;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  slCppvm.cppvmDistObj("slist");

  slCppvm.resize(7);
  int i;
  slist<int>::iterator j;
  j=slCppvm.begin();
  for(i=0;i<500;i++){
    // update message mailbox
    *j = i;
    slCppvm.cppvmWriteMboxInfo();
  }

  cout << "send objects..." << endl;

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                           CPPvmSBparent);
  
  // fill slists
  slCppvm.resize(0);
  for(i=0;i<5;i++){
    slCppvm.push_front(i);
  }
  sl.resize(0);
  for(i=0;i<3;i++){
    sl.push_front(i);
  }
  
  // send objects to parent process
  sendStrm << slCppvm << sl;

  return 0;
}




