// stl stack class: cppvm send/rec/distributed 

#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

void printStack(stack<int>& data)
{
  while(data.size()>0){
    cout << data.top() << " ";
    data.pop();
  }
}

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlStack<int> queCppvm;
  stack<int> que;

  // spawn child process, redirect output
  cppvmCatchout catchOut(CPPvmStdout);
  cppvmSpawnConnection child("stlstack2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  queCppvm.cppvmDistObj("stack");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    queCppvm.cppvmReadMboxInfo();
    cout << '\r';
    printStack(queCppvm);
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive data from child process
  recStrm >> queCppvm >> que;
 
  cout << "received objects: " ;
  printStack(queCppvm);
  cout << " and: ";
  printStack(que);
  cout << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

