// stl complex class: cppvm send/rec/distributed 

#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlString strCppvm;
  string str;

  // spawn child process, redirect output
  cppvmCatchout catchOut(CPPvmStdout);
  cppvmSpawnConnection child("stlstring2");

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  strCppvm.cppvmDistObj("string");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    strCppvm.cppvmReadMboxInfo();
    cout << '\r' 
         << strCppvm;
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive data from child process
  recStrm >> strCppvm >> str;
  
  cout << "received objects: " 
       << strCppvm << " and: "
       << str << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

