// stl valarray class: cppvm send/rec/distributed 

#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

void printValarray(valarray<int>& data)
{
  unsigned int i;
  for(i=0; i<data.size(); i++){
    cout << data[i] << " ";
  }
}

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlValarray<int> valarrCppvm;
  valarray<int> valarr;

  // spawn child process, redirect output
  cppvmCatchout catchOut(CPPvmStdout);
  cppvmSpawnConnection child("stlvalarray2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  valarrCppvm.cppvmDistObj("valarray");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    valarrCppvm.cppvmReadMboxInfo();
    cout << '\r';
    printValarray(valarrCppvm);
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive data from child process
  recStrm >> valarrCppvm >> valarr;
  
  cout << "received objects: " ;
  printValarray(valarrCppvm);
  cout << " and: ";
  printValarray(valarr);
  cout << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

