#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlValarray<int> valarrCppvm;
  valarray<int> valarr(3);

  cout << "distributed object..." << endl;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  valarrCppvm.cppvmDistObj("valarray");

  // resize valarray
  valarrCppvm.resize(7);

  int i;
  for(i=0;i<500;i++){
    // update message mailbox
    valarrCppvm[0] = i;
    valarrCppvm.cppvmWriteMboxInfo();
  }
  
  cout << "send objects..." << endl;

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                           CPPvmSBparent);
  
  // fill valarrays
  for(i=0;i<3;i++){
    valarr[i] = i;
  }
  valarrCppvm.resize(5);
  for(i=0;i<5;i++){
    valarrCppvm[i] = i+1;
  }
  
  // send objects to parent process
  sendStrm << valarrCppvm << valarr;

  return 0;
}

