// stl vector class: cppvm send/rec/distributed 

#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

void printVector(vector<int>& data)
{
  vector<int>::iterator i;
  for (i=data.begin(); i != data.end() ; i++) {
    cout << *i << " ";
  }
}

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlVector<int> vectCppvm;
  vector<int> vect;

  // spawn child process, redirect output
  cppvmCatchout catchOut(CPPvmStdout);
  cppvmSpawnConnection child("stlvector2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  vectCppvm.cppvmDistObj("vector");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    vectCppvm.cppvmReadMboxInfo();
    cout << '\r';
    printVector(vectCppvm);
    cout.flush();
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive data from child process
  recStrm >> vectCppvm >> vect;
  
  cout << "received objects: " ;
  printVector(vectCppvm);
  cout << " and: ";
  printVector(vect);
  cout << endl;

  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

