#include "cppvm.h"

#ifndef CPPvmDoNotUseStdNamespace
// stl namespace
using namespace std;
#endif

int
main()
{
  // connect to pvm
  cppvmConnection pvmConn;

  cppvmStlVector<int> vectCppvm;
  vector<int> vect(3);

  cout << "distributed object..." << endl;

  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  vectCppvm.cppvmDistObj("vector");

  // resize vector
  vectCppvm.resize(7);

  int i;
  for(i=0;i<500;i++){
    // update message mailbox
    vectCppvm[0] = i;
    vectCppvm.cppvmWriteMboxInfo();
  }

  cout << "send objects..." << endl;

  /////////////////////////
  // send/receive object //
  /////////////////////////

  // send descriptor
  // (blocking send 
  //  to parent process)
  cppvmSendStream sendStrm(pvmConn, 
                           CPPvmSBparent);
  
  // fill vectors
  for(i=0;i<3;i++){
    vect[i] = i;
  }
  vectCppvm.resize(5);
  for(i=0;i<5;i++){
    vectCppvm[i] = i+1;
  }
  
  // send objects to parent process
  sendStrm << vectCppvm << vect;

  return 0;
}
