// cppvm template example

#include "cppvm.h"
// include new class 'minimal'
#include "minimal.h"
// include new template class 'myTemplate'
#include "template.h"

void
templExample()
{
  // connect to pvm
  cppvmConnection pvmConn;

  // use one of these object
  // ATTENTION: it must be the
  // same as in 'templ2.cpp'
  // standard C type
  myTemplate<int> templObj;
  // cppvm class
  //myTemplate<cppvmDouble> templObj;
  // user defined class derived from 'cppvmObject'
  //myTemplate<minimal> templObj;

  // catchout to stdout 
  cppvmCatchout catchout(CPPvmStdout);
  // spawn child process 'templ2'
  cppvmSpawnConnection child("templ2");
  
  /////////////////////////
  // distributed object  //
  /////////////////////////

  // register the object 
  // as a distributed object
  templObj.cppvmDistObj("templateObject");

  int i;
  for(i=0;i<500;i++){
    // update the local value with the value
    // in the message box
    templObj.cppvmReadMboxInfo();
    cout << '\r' 
         << templObj.integerValue;
    cout.flush(); 
  }
  cout << endl;
  
  /////////////////////////
  // send/receive object //
  /////////////////////////

  // receive descriptor	  
  // (blocking receive 
  //  from child process)
  cppvmReceiveStream recStrm(child, 
                             CPPvmRBchild);

  // receive message from child process
  recStrm >> templObj;
  
  cout << "received value: " 
       << templObj.integerValue << endl;

  // halt the virtual machine
  pvmConn.halt();
}

int
main(){
  CPPvmTryAll(templExample())
  return 0;
}
