// seat reservation
#include "cppvm.h"

int
main2()
{
  // connect to pvm
  cppvmConnection pvmConn;

  // catchout to stdout 
  cppvmCatchout catchout(CPPvmStdout);

  // semaphores
  cppvmSemaphore reservation("seatReservation");
  cppvmSemaphore ready("synchronize");
  // set number of allowed entries
  reservation.setNumber(1);
  ready.setNumber(0);

  // spawn child process 'terminalB'
  cppvmSpawnConnection child("terminalB");

  // seat number object
  cppvmInt seats(0);
  // register the object 
  // as distributed object
  seats.cppvmDistObj("seats");

  bool maxReached = false;

  while(maxReached==false){
    // enter critical section
    reservation.enter();

    // reserve seat
    seats.cppvmReadMboxInfo();
    if((int)seats==100){
      maxReached = true;
    }
    else{
      cout << "terminalA, reservation for seat no." 
           << seats << endl;
      // set next available seat
      seats++;
      seats.cppvmWriteMboxInfo();
    }

    // leave critical section
    reservation.leave();
  }
  
  // wait for child process
  ready.enter();
  
  // halt the virtual machine
  pvmConn.halt();

  return 0;
}

int
main(){
  CPPvmTryAll(main2())
  return 0;
 
}
