// class 'warehouse' implementation

// include specification file
#include "warehouse.h"

// default constructor
warehouse::warehouse()
{
  // distributed object
  ware=0;
  ware.cppvmDistObj("ware");

  // set semaphore names
  notFull.setName("notFull");
  notEmpty.setName("notEmpty");
  access.setName("access");
}

// destructor
warehouse::~warehouse()
{
}

// init
// can only be called one time
void
warehouse::init(unsigned int number)
{
  notFull.setNumber(number);
  notEmpty.setNumber(0);
  access.setNumber(1);
}

// resize
void
warehouse::resize(unsigned int number)
{
  notFull.resetNumber(number);
  notEmpty.resetNumber(0);
  access.resetNumber(1);
}

// get
void
warehouse::get()
{
  notEmpty.enter();
  access.enter();
  
  // remove ware
  ware.cppvmReadMboxInfo();
  ware--;
  ware.cppvmWriteMboxInfo();
  cout << "get: number of objects in warehouse: " 
       << ware << endl;
  
  access.leave();
  notFull.leave();
}

// put
void
warehouse::put()
{
  notFull.enter();
  access.enter();
  
  // add ware
  ware.cppvmReadMboxInfo();
  ware++;
  ware.cppvmWriteMboxInfo();
  cout << "put: number of objects in warehouse: " 
       << ware << endl;
  
  access.leave();
  notEmpty.leave();
}


