/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_bool.h 
@SE  CREATED     : 29.9.1999
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : pvm bool class
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC PII 366
@SI  COMPILER        : gcc version 2.91.66
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_BOOL_INCLUDE
#define _PVM_BOOL_INCLUDE


/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_sida.h"

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/
#define PVM_BOOL_MODULE "pvm_bool.h"

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/


/*@@*****************************   CLASS   ***********************************
***
@KN  CLASS NAME    : cppvmBool
@KB  BASE CLASS    :
@KA  AUTHOR        : goerzig
@K#  
@KD  DESCRIPTION   : bool class
@KC  CONSTRAINTS   : 
******************************************************************************/
class cppvmBool : public cppvmSingleData{
public:

  cppvmBool();
  cppvmBool(bool value_);
  cppvmBool(const cppvmBool&);
  virtual ~cppvmBool();

  void write(bool value_);
  bool read();

  virtual double readValDouble(){return (double) value;}
  virtual void   writeValDouble(double value_){
    if(value_==0.0){
      value = false;
    }
    else{
      value = true;
    }
  }

  bool operator==(const cppvmBool&);
  bool operator==(const cppvmBool&) const;
  bool operator!=(const cppvmBool& obj) const {
    return ! (operator==(obj));
  }
  cppvmBool& operator=(const cppvmBool&);

  virtual bool operator+(const cppvmBool& obj){
    int result=((int)value + (int)obj.value);
    if(result<=0){
      return false;
    }
    else{
      return true;
    }
  }
  virtual bool operator-(const cppvmBool& obj){
    int result=((int)value - (int)obj.value);
    if(result<=0){
      return false;
    }
    else{
      return true;
    }
  }
  // these operators assume that true==1 and false==0
  virtual bool operator++(){
    if(value==false){
      value = true;
    }
    return value;
  }
  virtual bool operator++(int){
    if(value==false){
      value = true;
    }
    return value;
  }
  virtual bool operator--(){
    if(value==true){
      value = false;
    }
    return value;
  }
  virtual bool operator--(int){
    if(value==true){
      value = false;
    }
    return value;
  }
  
  virtual void cppvmScanFrom(istream& = cin);
  virtual void cppvmPrintOn(ostream& = cout);

  virtual void cppvmTransfer();
  
  CPPvmBuildInMsgTagMethodsDeclaration(CPPvmMsgTagClassBool)

  bool* getPtr(){return &value;}

  operator bool() {return value;} 

  bool operator&&(cppvmBool val)
  {
    return (value && val.value);
  }
  bool operator||(cppvmBool val)
  {
    return (value || val.value);
  
  }
  bool operator!()
  {
    return !value;
  }
  bool operator&&(bool val)
  {
    return (value && val);
  }
  bool operator||(bool val)
  {
    return (value || val);
  }
protected:
  bool value;
  char transferValue;
};

inline bool operator+(bool value, cppvmBool obj)
{
  return (bool)(obj.operator+(cppvmBool(value)));
}
inline bool operator-(bool value, cppvmBool obj)
{
  return (bool)(obj.operator-(cppvmBool(value)));
}

inline bool operator&&(bool value, cppvmBool obj)
{
  return (value && ((bool)obj));
}

inline bool operator||(bool value, cppvmBool obj)
{
  return (value || ((bool)obj));
}

#endif
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/



