/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_char.h 
@SE  CREATED     : 30.1.1998
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : pvm char class
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_CHAR_INCLUDE
#define _PVM_CHAR_INCLUDE


/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_sida.h"

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/
#define PVM_CHAR_MODULE "pvm_char.h"

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/


/*@@*****************************   CLASS   ***********************************
***
@KN  CLASS NAME    : cppvmChar
@KB  BASE CLASS    :
@KA  AUTHOR        : goerzig
@K#  
@KD  DESCRIPTION   : char class
@KC  CONSTRAINTS   : 
******************************************************************************/
class cppvmChar : public cppvmSingleData{
public:

  cppvmChar();
  cppvmChar(char value_);
  cppvmChar(const cppvmChar&);
  virtual ~cppvmChar();

  void write(char value_);
  char read();

  virtual double readValDouble(){return (double) value;}
  virtual void   writeValDouble(double value_){value = (char) value_;}

  bool operator==(const cppvmChar&);
  bool operator==(const cppvmChar&) const;
  bool operator!=(const cppvmChar& obj) const {
    return ! (operator==(obj));
  }
  cppvmChar& operator=(const cppvmChar&);
  virtual char operator+(const cppvmChar& obj){
    return (char)((int)value + (int)obj.value);
  }
  virtual char operator-(const cppvmChar& obj){
    return (char)((int)value - (int)obj.value);
  }
  virtual char operator++(){
    ++value;
    return value;
  }
  virtual char operator++(int){
    value++;
    return value;
  }
  virtual char operator--(){
    --value;
    return value;
  }
  virtual char operator--(int){
    value--;
    return value;
  }
  
  
  virtual void cppvmScanFrom(istream& = cin);
  virtual void cppvmPrintOn(ostream& = cout);

  virtual void cppvmTransfer();
  
  CPPvmBuildInMsgTagMethodsDeclaration(CPPvmMsgTagClassChar)

  char* getPtr() {return &value;}

  operator char() {return value;} 

protected:
  char value;
};

inline char operator+(char value, cppvmChar obj)
{
  return (char)(value + (char)obj);
}
inline cppvmChar operator-(char value, cppvmChar obj)
{
  return (char)(value - (char)obj);
}


#endif
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/



