/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_cose.h 
@SE  CREATED     : 18.2.1999
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : complex semaphore class for semaphore server
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_COSE_INCLUDE
#define _PVM_COSE_INCLUDE


/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_obj.h"

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/
#define PVM_COSE_MODULE "pvm_cose.h"

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/

// class declarations to avoid cyclic includes
class cppvmObjectCollection;
class cppvmString;
class cppvmInt;

/*@@*****************************   CLASS   ***********************************
***
@KN  CLASS NAME    : cppvmComplexSemaphore
@KB  BASE CLASS    :
@KA  AUTHOR        : goerzig
@K#  
@KD  DESCRIPTION   : array base class
@KC  CONSTRAINTS   : 
******************************************************************************/
class cppvmComplexSemaphore : public cppvmObject{
public:

  cppvmComplexSemaphore(cppvmString semaName);
  virtual ~cppvmComplexSemaphore();

  bool operator==(const cppvmComplexSemaphore&);
  bool operator==(const cppvmComplexSemaphore&) const;
  bool operator!=(const cppvmComplexSemaphore& obj) const {
    return ! (operator==(obj));
  }

  virtual void cppvmScanFrom(istream& = cin);
  virtual void cppvmPrintOn(ostream& = cout);

  virtual void cppvmTransfer();
    
  CPPvmBuildInMsgTagMethodsDeclaration(CPPvmMsgTagClassComplexSemaphore)

public:
  bool setNumber(unsigned int newNumber);
  unsigned int getNumber(){return (unsigned int)((int)semaNumber);}
  
  bool enter(int tid);
  bool enterNB();
  int leave();

  bool compareSemaName(cppvmString& compName){return compName==complexSemaName;}

protected:
  void addToList(int tid);
  int  getAndRemoveTidFromList();
  
protected:
  cppvmInt semaNumber;
  cppvmString complexSemaName;
  cppvmObjectCollection queueTidList;

  bool firstSetNumberCall;
  
private:
  // do not allow to copy elements
  cppvmComplexSemaphore(const cppvmComplexSemaphore&);
  cppvmComplexSemaphore& operator=(const cppvmComplexSemaphore&);
};

#endif
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/



