/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_def.h 
@SE  CREATED     : 5.12.1997
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : definitions for pvm classes
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       :
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_DEF_INCLUDE
#define _PVM_DEF_INCLUDE

/*@@@**************************************************************************
**********                                                           **********
*******                 CONSTANTS FOR TYPE DEFINITIONS                  *******
**********                                                           **********
******************************************************************************/

// in some compilers the datatype bool exists already
// in others it is not implemented
#ifndef CPPvmCompilerWithoutBoolType
#define CPPvmBoolExists
#endif

// print errors (exception on stream)
#define CPPvmErrorMsg

// uncomment this for fast access methods
// (like operator[] in cppvmObjectCollection)
// CPPvmFastAccess

/*@@***************************   CONSTANT   **********************************
***
@CN  CONSTANT NAME : true
@CD  DESCRIPTION   : true value for type 'bool'
@CD                  this SHOULD be a standard constant
@CD                  (ANSI/ISO); remove this if the compiler knows it
***
******************************************************************************/
#ifndef CPPvmBoolExists
#define true 1
#endif

/*@@***************************   CONSTANT   **********************************
***
@CN  CONSTANT NAME : false
@CD  DESCRIPTION   : false value for type 'bool'
@CD                  this SHOULD be a standard constant
@CD                  (ANSI/ISO); remove this if the compiler knows it
***
******************************************************************************/
#ifndef CPPvmBoolExists
#define false 0
#endif

/*@@@**************************************************************************
**********                                                           **********
*******                        EXPORTED TYPES                           *******
**********                                                           **********
******************************************************************************/

/*@@*****************************   TYPE   ************************************
***
@TN  TYPE NAME   : bool
@TD  DESCRIPTION : Boolean value; this SHOULD be a standard data type
@TD                (ANSI/ISO); remove this if the compiler knows the
@TD                bool type
***
******************************************************************************/
#ifndef CPPvmBoolExists
typedef int bool;
#endif

/*@@@**************************************************************************
**********                                                           **********
*******                       EXPORTED CONSTANTS                        *******
**********                                                           **********
******************************************************************************/

// reserved cppvm classes message tags range
#define CPPvmMsgTagMin                 99000
#define CPPvmMsgTagMax                 99999

// message tag for blocking send handshake
#define CPPvmHandshakeMsgTag           99900

// message tags for not send/receivable cppvm classes
#define CPPvmMsgTagNoMessagePassing    99901

// do not use a message tag for each object; this value is used in
// the 'cppvmObject' constructor
#define CPPvmNoObjectMsgTag            99902

// message tags for send/receivable cppvm classes
#define CPPvmMsgTagClassObjcoll                  99910
#define CPPvmMsgTagClassType                     99911
#define CPPvmMsgTagClassSingleData               99912
#define CPPvmMsgTagClassString                   99913
#define CPPvmMsgTagClassInt                      99914
#define CPPvmMsgTagClassFloat                    99915
#define CPPvmMsgTagClassDouble                   99916
#define CPPvmMsgTagClassLong                     99917
#define CPPvmMsgTagClassChar                     99918
#define CPPvmMsgTagClassBool                     99919
#define CPPvmMsgTagClassArrayData                99920
#define CPPvmMsgTagClassArrayInt                 99921
#define CPPvmMsgTagClassArrayLong                99922
#define CPPvmMsgTagClassArrayFloat               99923
#define CPPvmMsgTagClassArrayDouble              99924
#define CPPvmMsgTagClassArrayChar                99925
#define CPPvmMsgTagClassArrayBool                99926
#define CPPvmMsgTagClassTask                     99927
#define CPPvmMsgTagClassComplexSemaphore         99928
#define CPPvmMsgTagClassStlVector                99929
#define CPPvmMsgTagClassStlDeque                 99930
#define CPPvmMsgTagClassStlList                  99931
#define CPPvmMsgTagClassStlSlist                 99932
#define CPPvmMsgTagClassStlSet                   99933
#define CPPvmMsgTagClassStlMultiset              99934
#define CPPvmMsgTagClassStlMap                   99935
#define CPPvmMsgTagClassStlMultimap              99936
#define CPPvmMsgTagClassStlComplex               99937
#define CPPvmMsgTagClassStlString                99938
#define CPPvmMsgTagClassNewSendStackDataPointer  99939
#define CPPvmMsgTagClassStlBitset                99940
#define CPPvmMsgTagClassStlQueue                 99941
#define CPPvmMsgTagClassStlPriorityqueue         99942
#define CPPvmMsgTagClassStlStack                 99943
#define CPPvmMsgTagClassStlValarray              99944
#define CPPvmMsgTagClassStlPair                  99945


/*@@@**************************************************************************
**********                                                           **********
*******                       EXPORTED VARIABLES                        *******
**********                                                           **********
******************************************************************************/


/*@@@**************************************************************************
**********                                                           **********
*******                       EXPORTED MACROS                           *******
**********                                                           **********
******************************************************************************/

#endif
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/
