/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_doub.h 
@SE  CREATED     : 30.1.1998
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : pvm double class
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_DOUB_INCLUDE
#define _PVM_DOUB_INCLUDE


/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_sida.h"

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/
#define PVM_DOUB_MODULE "pvm_doub.h"

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/


/*@@*****************************   CLASS   ***********************************
***
@KN  CLASS NAME    : cppvmDouble
@KB  BASE CLASS    :
@KA  AUTHOR        : goerzig
@K#  
@KD  DESCRIPTION   : double class
@KC  CONSTRAINTS   : 
******************************************************************************/
class cppvmDouble : public cppvmSingleData{
public:

  cppvmDouble();
  cppvmDouble(double value_);
  cppvmDouble(const cppvmDouble&);
  virtual ~cppvmDouble();

  void write(double value_);
  double read();

  virtual double readValDouble(){return value;}
  virtual void   writeValDouble(double value_){value = value_;}

  bool operator==(const cppvmDouble&);
  bool operator==(const cppvmDouble&) const;
  bool operator!=(const cppvmDouble& obj) const {
    return ! (operator==(obj));
  }
  cppvmDouble& operator=(const cppvmDouble&);
  virtual double operator+(const cppvmDouble& obj){
    return value + obj.value;
  }
  virtual double operator-(const cppvmDouble& obj){
    return value - obj.value;
  }
  virtual double operator++(){
    ++value;
    return value;
  }
  virtual double operator++(int){
    value++;
    return value;
  }
  virtual double operator--(){
    --value;
    return value;
  }
  virtual double operator--(int){
    value--;
    return value;
  }
  
  
  virtual void cppvmScanFrom(istream& = cin);
  virtual void cppvmPrintOn(ostream& = cout);

  virtual void cppvmTransfer();
  
  CPPvmBuildInMsgTagMethodsDeclaration(CPPvmMsgTagClassDouble)

  double* getPtr() {return &value;}

  operator double() {return value;} 

protected:
  double value;
};

inline double operator+(double value, cppvmDouble obj)
{
  return value + (double)obj;
}
inline double operator-(double value, cppvmDouble obj)
{
  return value - (double)obj;
}


#endif
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/



