/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_exfo.h 
@SE  CREATED     : 5.12.1997
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : forbidden call class for exception handling
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : the messages can be suppressed by setting 'CPPvmErrorMsg'
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_EXFOR_INCLUDE
#define _PVM_EXFOR_INCLUDE

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_exce.h"


/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/

/*@@*****************************   CLASS   ***********************************
***
@KN  CLASS NAME    : cppvmExceptionForbiddenCall
@KB  BASE CLASS    :
@KA  AUTHOR        : goerzig
@K#  
@KD  DESCRIPTION   : forbidden call class for exception handling
@KC  CONSTRAINTS   : 
******************************************************************************/
class cppvmExceptionForbiddenCall : public cppvmException{
public:
  cppvmExceptionForbiddenCall()
      : cppvmException() {}
  cppvmExceptionForbiddenCall(const char *mo, const char *cl, 
                              const char *me, const char *er)
      : cppvmException(mo, cl, me, er) {}
  cppvmExceptionForbiddenCall(const cppvmExceptionForbiddenCall& obj);
  virtual ~cppvmExceptionForbiddenCall();
  
  cppvmExceptionForbiddenCall& operator=(const cppvmExceptionForbiddenCall& obj);
  bool operator==(const cppvmExceptionForbiddenCall&);
  bool operator==(const cppvmExceptionForbiddenCall&) const;
  bool operator!=(const cppvmExceptionForbiddenCall& obj) const {
    return ! (operator==(obj));
  }

  virtual void printOn(ostream& = cout);
};

#endif
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/

