/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_floa.h 
@SE  CREATED     : 30.1.1998
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : pvm float class
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_FLOA_INCLUDE
#define _PVM_FLOA_INCLUDE


/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_sida.h"

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/
#define PVM_FLOA_MODULE "pvm_floa.h"

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/


/*@@*****************************   CLASS   ***********************************
***
@KN  CLASS NAME    : cppvmFloat
@KB  BASE CLASS    :
@KA  AUTHOR        : goerzig
@K#  
@KD  DESCRIPTION   : float class
@KC  CONSTRAINTS   : 
******************************************************************************/
class cppvmFloat : public cppvmSingleData{
public:

  cppvmFloat();
  cppvmFloat(float value_);
  cppvmFloat(const cppvmFloat&);
  virtual ~cppvmFloat();

  void write(float value_);
  float read();

  virtual double readValDouble(){return (double) value;}
  virtual void   writeValDouble(double value_){value = (float) value_;}

  bool operator==(const cppvmFloat&);
  bool operator==(const cppvmFloat&) const;
  bool operator!=(const cppvmFloat& obj) const {
    return ! (operator==(obj));
  }
  cppvmFloat& operator=(const cppvmFloat&);
  virtual float operator+(const cppvmFloat& obj){
    return value + obj.value;
  }
  virtual float operator-(const cppvmFloat& obj){
    return value - obj.value;
  }
  virtual float operator++(){
    ++value;
    return value;
  }
  virtual float operator++(int){
    value++;
    return value;
  }
  virtual float operator--(){
    --value;
    return value;
  }
  virtual float operator--(int){
    value--;
    return value;
  }
  
  
  virtual void cppvmScanFrom(istream& = cin);
  virtual void cppvmPrintOn(ostream& = cout);

  virtual void cppvmTransfer();
  
  CPPvmBuildInMsgTagMethodsDeclaration(CPPvmMsgTagClassFloat)

  float* getPtr() {return &value;}

  operator float() {return value;} 

protected:
  float value;
};

inline float operator+(float value, cppvmFloat obj)
{
  return value + (float)obj;
}
inline float operator-(float value, cppvmFloat obj)
{
  return value - (float)obj;
}


#endif
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/



