/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_globvar.h 
@SE  CREATED     : 17.10.2001
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : class for global variables
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_GLOBVAR_INCLUDE
#define _PVM_GLOBVAR_INCLUDE

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_inmu.h"

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                              TYPES                              *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/

/*@@*****************************   CLASS   ***********************************
***
@KN  CLASS NAME    : cppvmGlobalVariables
@KB  BASE CLASS    :
@KA  AUTHOR        : goerzig
@K#  
@KD  DESCRIPTION   : global variables class
@KC  CONSTRAINTS   : 
******************************************************************************/
class cppvmGlobalVariables {
public:
  
  cppvmGlobalVariables();
  virtual ~cppvmGlobalVariables();

public:
#ifdef CPPvmThread
  // global variables
  static cppvmInternalMutex communicationMutex;
  static cppvmInternalMutex mutexFunction;
#endif

#ifdef CPPvmThread
#ifndef WIN32
  // mutex variable for unix version
  static pthread_mutex_t unixCommunicationMutex;
  static pthread_mutex_t unixMutexFunction;
#endif
#endif
private:
  // do not allow copy constructor
  cppvmGlobalVariables(const cppvmGlobalVariables&){}
  // do not allow assignments
  cppvmGlobalVariables& operator=(const cppvmGlobalVariables&){ return *this; }

};

#endif 
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/



