/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_int.h 
@SE  CREATED     : 30.1.1998
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : pvm integer class
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_INT_INCLUDE
#define _PVM_INT_INCLUDE


/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_sida.h"

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/
#define PVM_INT_MODULE "pvm_int.h"

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/


/*@@*****************************   CLASS   ***********************************
***
@KN  CLASS NAME    : cppvmInt
@KB  BASE CLASS    :
@KA  AUTHOR        : goerzig
@K#  
@KD  DESCRIPTION   : integer class
@KC  CONSTRAINTS   : 
******************************************************************************/
class cppvmInt : public cppvmSingleData{
public:

  cppvmInt();
  cppvmInt(int value_);
  cppvmInt(const cppvmInt&);
  virtual ~cppvmInt();

  void write(int value_);
  int read();

  virtual double readValDouble(){return (double) value;}
  virtual void   writeValDouble(double value_){value = (int) value_;}

  bool operator==(const cppvmInt&);
  bool operator==(const cppvmInt&) const;
  bool operator!=(const cppvmInt& obj) const {
    return ! (operator==(obj));
  }
  cppvmInt& operator=(const cppvmInt&);
  virtual int operator+(const cppvmInt& obj){
    return value + obj.value;
  }
  virtual int operator-(const cppvmInt& obj){
    return value - obj.value;
  }
  virtual int operator++(){
    ++value;
    return value;
  }
  virtual int operator++(int){
    value++;
    return value;
  }
  virtual int operator--(){
    --value;
    return value;
  }
  virtual int operator--(int){
    value--;
    return value;
  }
  
  
  virtual void cppvmScanFrom(istream& = cin);
  virtual void cppvmPrintOn(ostream& = cout);

  virtual void cppvmTransfer();
  
  CPPvmBuildInMsgTagMethodsDeclaration(CPPvmMsgTagClassInt)

  int* getPtr() {return &value;}

  operator int() {return value;} 

protected:
  int value;
};

inline int operator+(int value, cppvmInt obj)
{
  return value + (int)obj;
}
inline int operator-(int value, cppvmInt obj)
{
  return value - (int)obj;
}

#endif
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/



