/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_long.h 
@SE  CREATED     : 30.1.1998
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : pvm long class
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_LONG_INCLUDE
#define _PVM_LONG_INCLUDE


/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_sida.h"

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/
#define PVM_LONG_MODULE "pvm_long.h"

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/


/*@@*****************************   CLASS   ***********************************
***
@KN  CLASS NAME    : cppvmLong
@KB  BASE CLASS    :
@KA  AUTHOR        : goerzig
@K#  
@KD  DESCRIPTION   : long class
@KC  CONSTRAINTS   : 
******************************************************************************/
class cppvmLong : public cppvmSingleData{
public:

  cppvmLong();
  cppvmLong(long value_);
  cppvmLong(const cppvmLong&);
  virtual ~cppvmLong();

  void write(long value_);
  long read();

  virtual double readValDouble(){return (double) value;}
  virtual void   writeValDouble(double value_){value = (long) value_;}

  bool operator==(const cppvmLong&);
  bool operator==(const cppvmLong&) const;
  bool operator!=(const cppvmLong& obj) const {
    return ! (operator==(obj));
  }
  cppvmLong& operator=(const cppvmLong&);
  virtual long operator+(const cppvmLong& obj){
    return value + obj.value;
  }
  virtual long operator-(const cppvmLong& obj){
    return value - obj.value;
  }
  virtual long operator++(){
    ++value;
    return value;
  }
  virtual long operator++(int){
    value++;
    return value;
  }
  virtual long operator--(){
    --value;
    return value;
  }
  virtual long operator--(int){
    value--;
    return value;
  }
  
  
  virtual void cppvmScanFrom(istream& = cin);
  virtual void cppvmPrintOn(ostream& = cout);

  virtual void cppvmTransfer();
  
  CPPvmBuildInMsgTagMethodsDeclaration(CPPvmMsgTagClassLong)

  long* getPtr() {return &value;}

  operator long() {return value;} 

protected:
  long value;
};

inline long operator+(long value, cppvmLong obj)
{
  return value + (long)obj;
}
inline long operator-(long value, cppvmLong obj)
{
  return value - (long)obj;
}


#endif
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/



