/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_mutex.h 
@SE  CREATED     : 25.07.2001
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : cppvm stl pair class
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_MUTEX_INCLUDE
#define _PVM_MUTEX_INCLUDE

#ifndef CPPvmDoNotUseTemplates

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_mutexcoll.h"
#include "pvm_globvar.h"

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/
#define CPPVM_STANDARD_MUTEX "cppvmMutexStandard"

/*@@@**************************************************************************
**********                                                           **********
*******                              TYPES                              *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                            FUNCTIONS                            *******
**********                                                           **********
******************************************************************************/

template <class T>
inline
void cppvmMutex (T& callElement, 
                 char *semaphoreName=CPPVM_STANDARD_MUTEX) {
#ifdef CPPvmThread
  cppvmGlobalVariables::mutexFunction.lock();
#endif

  cppvmMutexCollection::enter(semaphoreName);                  
  callElement();
  cppvmMutexCollection::leave();                  

#ifdef CPPvmThread
  cppvmGlobalVariables::mutexFunction.unlock();
#endif
}

template <class T, class R>
inline
void cppvmMutex (T& callElement, R& returnVal, 
                 char *semaphoreName) {
#ifdef CPPvmThread
  cppvmGlobalVariables::mutexFunction.lock();
#endif

  cppvmMutexCollection::enter(semaphoreName);                  
  returnVal = callElement();
  cppvmMutexCollection::leave();                  

#ifdef CPPvmThread
  cppvmGlobalVariables::mutexFunction.unlock();
#endif
}



#endif // CPPvmDoNotUseTemplates

#endif 
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/



