/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_mutexcoll.h 
@SE  CREATED     : 29.07.2001
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : semaphore collection for cppvmMutex
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_MUTEXCOLL_INCLUDE
#define _PVM_MUTEXCOLL_INCLUDE

// is only used by 'cppvmMutex' ('pvm_mutex.h')
// and 'cppvmMutex' is using templates
#ifndef CPPvmDoNotUseTemplates

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_cincl.h"

// class declarations to avoid cyclic includes
class cppvmSemaphore;

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/
#define PVM_MUTEXCOLL_MODULE "pvm_mutexcoll.h"

/*@@***************************   CONSTANT   **********************************
***
@CN  CONSTANT NAME : CPPvmMutexCollMapMaxSize
@CD  DESCRIPTION   : maximal size for the mutex map
***
******************************************************************************/
#define CPPvmMutexCollMapMaxSize 10000

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/

/*@@*****************************   CLASS   ***********************************
***
@KN  CLASS NAME    : cppvmMutexCollection
@KB  BASE CLASS    :
@KA  AUTHOR        : goerzig
@K#  
@KD  DESCRIPTION   : mutex collection
@KC  CONSTRAINTS   : 
******************************************************************************/
class cppvmMutexCollection {
public:

  cppvmMutexCollection();
  virtual ~cppvmMutexCollection();

  static void enter(char *semaphoreName);
  static void leave();

protected:
  static cppvmSemaphore semaphoreObj;

};

//CPPvmDoNotUseTemplates
#endif

#endif
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/
