/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_noha.h 
@SE  CREATED     : 31.07.2000
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : notification class for added hosts
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_NOHA_INCLUDE
#define _PVM_NOHA_INCLUDE


/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/

#include "pvm_noti.h"
#include "pvm_arch.h"

/*@@@**************************************************************************
**********                                                           **********
*******                 CONSTANTS FOR TYPE DEFINITIONS                  *******
**********                                                           **********
******************************************************************************/
#define PVM_NOHA_HEADER "pvm_noha.h"

/*@@@**************************************************************************
**********                                                           **********
*******                        EXPORTED TYPES                           *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                            MACROS                               *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/


/*@@*****************************   CLASS   ***********************************
***
@KN  CLASS NAME    : cppvmNotificationHostAdd
@KB  BASE CLASS    :
@KA  AUTHOR        : goerzig
@K#  
@KD  DESCRIPTION   : notification class for added hosts
@KC  CONSTRAINTS   : 
******************************************************************************/
class cppvmNotificationHostAdd : public cppvmNotification
{
public:
  cppvmNotificationHostAdd();
  cppvmNotificationHostAdd(int msgTag);
  cppvmNotificationHostAdd(int msgTag, int number);
  virtual ~cppvmNotificationHostAdd();
  cppvmNotificationHostAdd(const cppvmNotificationHostAdd&);
  cppvmNotificationHostAdd& operator=(const cppvmNotificationHostAdd& obj);
  bool operator!=(const cppvmNotificationHostAdd& obj) const {
    return ! (cppvmNotification::operator==(obj));
  }
  bool operator==(const cppvmNotificationHostAdd& obj) {
    return cppvmNotification::operator==(obj);
  }
  
  bool operator==(const cppvmNotificationHostAdd& obj) const {
    return cppvmNotification::operator==(obj);
  }

  virtual void cppvmPrintOn(ostream& strm= cout);
  virtual void cppvmScanFrom(istream& /*strm= cin*/) {};

  void set(int msgTag);
  void set(int msgTag, int number);
  void reset(int number);

  cppvmArrayInt getAddedHostDaemonTids();
  
};

#endif
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/
