/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_nohd.h 
@SE  CREATED     : 30.07.2000
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : notification class for deleted hosts
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_NOHD_INCLUDE
#define _PVM_NOHD_INCLUDE


/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/

#include "pvm_noti.h"

/*@@@**************************************************************************
**********                                                           **********
*******                 CONSTANTS FOR TYPE DEFINITIONS                  *******
**********                                                           **********
******************************************************************************/
#define PVM_NOHD_HEADER "pvm_nohd.h"

/*@@@**************************************************************************
**********                                                           **********
*******                        EXPORTED TYPES                           *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                            MACROS                               *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/


/*@@*****************************   CLASS   ***********************************
***
@KN  CLASS NAME    : cppvmNotificationHostDelete
@KB  BASE CLASS    :
@KA  AUTHOR        : goerzig
@K#  
@KD  DESCRIPTION   : notification class for deleted hosts
@KC  CONSTRAINTS   : 
******************************************************************************/
class cppvmNotificationHostDelete : public cppvmNotification
{
public:
  cppvmNotificationHostDelete();
  cppvmNotificationHostDelete(int msgTag);
  cppvmNotificationHostDelete(int msgTag, int number, int* tids);
  cppvmNotificationHostDelete(int msgTag, cppvmArrayInt& tids);
  cppvmNotificationHostDelete(int msgTag, char *hostName);
  virtual ~cppvmNotificationHostDelete();
  cppvmNotificationHostDelete(const cppvmNotificationHostDelete&);
  cppvmNotificationHostDelete& operator=(const cppvmNotificationHostDelete& obj);
  bool operator!=(const cppvmNotificationHostDelete& obj) const {
    return ! (cppvmNotification::operator==(obj));
  }
  bool operator==(const cppvmNotificationHostDelete& obj) {
    return cppvmNotification::operator==(obj);
  }
  
  bool operator==(const cppvmNotificationHostDelete& obj) const {
    return cppvmNotification::operator==(obj);
  }

  virtual void cppvmPrintOn(ostream& strm= cout);
  virtual void cppvmScanFrom(istream& /*strm= cin*/) {};

  void set(int msgTag);
  void set(int msgTag, int number, int* tids);
  void set(int msgTag, cppvmArrayInt& tids);
  void set(int msgTag, char *hostName);

  int getDeletedHostDaemonTid();

private:
  cppvmArrayInt hostDeleteDaemonTids;
};

#endif
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/
