/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_note.h 
@SE  CREATED     : 30.07.2000
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : notification class for exited tasks
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_NOTE_INCLUDE
#define _PVM_NOTE_INCLUDE


/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/

#include "pvm_noti.h"

/*@@@**************************************************************************
**********                                                           **********
*******                 CONSTANTS FOR TYPE DEFINITIONS                  *******
**********                                                           **********
******************************************************************************/
#define PVM_NOTE_HEADER "pvm_note.h"

/*@@@**************************************************************************
**********                                                           **********
*******                        EXPORTED TYPES                           *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                            MACROS                               *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/


/*@@*****************************   CLASS   ***********************************
***
@KN  CLASS NAME    : cppvmNotificationTaskExit
@KB  BASE CLASS    :
@KA  AUTHOR        : goerzig
@K#  
@KD  DESCRIPTION   : notification class for exited tasks
@KC  CONSTRAINTS   : 
******************************************************************************/
class cppvmNotificationTaskExit : public cppvmNotification
{
public:
  cppvmNotificationTaskExit();
  cppvmNotificationTaskExit(int msgTag);
  cppvmNotificationTaskExit(int msgTag, int number, int* tids);
  cppvmNotificationTaskExit(int msgTag, cppvmArrayInt& tids);
  cppvmNotificationTaskExit(int msgTag, cppvmSpawnConnection& child);
  cppvmNotificationTaskExit(int msgTag, cppvmSpawnMultiConnection& children);
  cppvmNotificationTaskExit(int msgTag, cppvmTask& task);
  cppvmNotificationTaskExit(int msgTag, char *taskName);
  virtual ~cppvmNotificationTaskExit();
  cppvmNotificationTaskExit(const cppvmNotificationTaskExit&);
  cppvmNotificationTaskExit& operator=(const cppvmNotificationTaskExit& obj);
  bool operator!=(const cppvmNotificationTaskExit& obj) const {
    return ! (cppvmNotification::operator==(obj));
  }
  bool operator==(const cppvmNotificationTaskExit& obj) {
    return cppvmNotification::operator==(obj);
  }
  
  bool operator==(const cppvmNotificationTaskExit& obj) const {
    return cppvmNotification::operator==(obj);
  }

  virtual void cppvmPrintOn(ostream& strm= cout);
  virtual void cppvmScanFrom(istream& /*strm= cin*/) {};

  void set(int msgTag);
  void set(int msgTag, int number, int* tids);
  void set(int msgTag, cppvmArrayInt& tids);
  void set(int msgTag, cppvmSpawnConnection& child);
  void set(int msgTag, cppvmSpawnMultiConnection& children);
  void set(int msgTag, cppvmTask& task);
  void set(int msgTag, char *taskName);

  int getExitTid();
  
protected:
  cppvmArrayInt exitTaskIds;
};

#endif
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/
