/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_nssdata.h 
@SE  CREATED     : 21.2.2000
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : template data for send stack (PvmDataInPlace)
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_NSSDATA_INCLUDE
#define _PVM_NSSDATA_INCLUDE

#ifndef CPPvmDoNotUseTemplates

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_obj.h"

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/

template <class T>
class cppvmNewSendStackDataPointer: public cppvmObject {
public:

// constructor/destructor
  cppvmNewSendStackDataPointer(T* pointer)
      : cppvmObject()
  {
    dp = pointer;
  }
  virtual ~cppvmNewSendStackDataPointer()
  {
    delete [] dp;
  }

  virtual void cppvmTransfer() {}
  CPPvmBuildInMsgTagMethodsStlDeclaration(CPPvmMsgTagClassNewSendStackDataPointer)

public:
  T* dp;
  
};

template <class T>
class cppvmNewSendStackData {
public:

  // constructor
  cppvmNewSendStackData(unsigned int num)
  {
    if(num==0){
      CPPvmInternalThrow( cppvmExceptionBadParameter("pvm_nssdata.h",
                                                     "cppvmNewSendStackData",
                                                     "constructor",
                                                     "array size (num) is 0"));
    }
    data = new T[num];
    cppvmAddToSendStack(new cppvmNewSendStackDataPointer<T>(data));
  }
  // constructor with externaly allocated memory
  cppvmNewSendStackData(T* pointer)
  {
    if(pointer==NULL){
      CPPvmInternalThrow( cppvmExceptionBadParameter("pvm_nssdata.h",
                                                     "cppvmNewSendStackData",
                                                     "constructor",
                                                     "parameter 'pointer' is NULL"));
    }
    data = pointer;
    cppvmAddToSendStack(new cppvmNewSendStackDataPointer<T>(data));
  }
  // the data is deleted by 'cppvmAddToSendStack'
  virtual ~cppvmNewSendStackData(){}

public:
  T* data;
  
};

#endif // CPPvmDoNotUseTemplates


#endif 
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/



