/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_sepr.h 
@SE  CREATED     : 18.2.1999
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : definitions for protocoll semaphore server <-> client
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_SEPR_INCLUDE
#define _PVM_SEPR_INCLUDE


/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                 CONSTANTS FOR TYPE DEFINITIONS                  *******
**********                                                           **********
******************************************************************************/
#define PVM_SEPR_HEADER "pvm_sepr.h"

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/

/*@@***************************   CONSTANT   **********************************
***
@CN  CONSTANT NAME : CPPvmToSemaphoreServerEnter 
@CD  DESCRIPTION   : tell the server to call enter operation for semaphore
***
******************************************************************************/
#define CPPvmToSemaphoreServerEnter    0

/*@@***************************   CONSTANT   **********************************
***
@CN  CONSTANT NAME : CPPvmToSemaphoreServerEnterNB 
@CD  DESCRIPTION   : tell the server to call non-blocking enter operation 
@CD                  for semaphore
***
******************************************************************************/
#define CPPvmToSemaphoreServerEnterNB  1

/*@@***************************   CONSTANT   **********************************
***
@CN  CONSTANT NAME : CPPvmToSemaphoreServerLeave
@CD  DESCRIPTION   : tell the server to call leave operation for semaphore
***
******************************************************************************/
#define CPPvmToSemaphoreServerLeave    2

/*@@***************************   CONSTANT   **********************************
***
@CN  CONSTANT NAME : CPPvmToSemaphoreServerSetNumber
@CD  DESCRIPTION   : tell the server to set the number of semaphore
@CD                  entries
***
******************************************************************************/
#define CPPvmToSemaphoreServerSetNumber 3

/*@@***************************   CONSTANT   **********************************
***
@CN  CONSTANT NAME : CPPvmToSemaphoreServerGetNumber
@CD  DESCRIPTION   : tell the server to send number of semaphore entries
***
******************************************************************************/
#define CPPvmToSemaphoreServerGetNumber 4

/*@@***************************   CONSTANT   **********************************
***
@CN  CONSTANT NAME : CPPvmToSemaphoreServerResetNumber
@CD  DESCRIPTION   : reset semaphore entry
***
******************************************************************************/
#define CPPvmToSemaphoreServerResetNumber  5

/*@@***************************   CONSTANT   **********************************
***
@CN  CONSTANT NAME : CPPvmFromSemaphoreServerOK
@CD  DESCRIPTION   : handshake send back from server to client
***
******************************************************************************/
#define CPPvmFromSemaphoreServerOK     100

/*@@***************************   CONSTANT   **********************************
***
@CN  CONSTANT NAME : CPPvmFromSemaphoreServerFailed
@CD  DESCRIPTION   : handshake send back from server to client
***
******************************************************************************/
#define CPPvmFromSemaphoreServerFailed 101

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/


/*@@@**************************************************************************
**********                                                           **********
*******                       EXPORTED FUNCTIONS                        *******
**********                                                           **********
******************************************************************************/

#endif
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/
