/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_stldeque.h 
@SE  CREATED     : 31.1.2000
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : cppvm stl deque class
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_STLDEQUE_INCLUDE
#define _PVM_STLDEQUE_INCLUDE

#ifndef CPPvmDoNotUseTemplates
#ifndef CPPvmDoNotUseStl

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_obj.h"
#include "pvm_stl.h"

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/

template <class T>
class cppvmStlDeque: public cppvmObject, public deque<T> {
  
public:
  cppvmStlDeque(): cppvmObject(), deque<T>() {}
  cppvmStlDeque(typename deque<T>::size_type n): cppvmObject(), deque<T>(n) {}
  cppvmStlDeque(typename deque<T>::size_type n, const T& value): 
      cppvmObject(), deque<T>(n, value) {}
  cppvmStlDeque(typename deque<T>::const_iterator first, 
                typename deque<T>::const_iterator last): 
      cppvmObject(), deque<T>(first, last) {}
  // constructors for cppvmStlDeque
  cppvmStlDeque(const cppvmStlDeque<T>& obj) : 
      cppvmObject(), deque<T>((const deque<T>&)obj){}
  // constructors for deque
  cppvmStlDeque(const deque<T>& obj) : 
      cppvmObject(), deque<T>(obj) {}
  // destructor
  virtual ~cppvmStlDeque() {}
  
  // cppvmStlDeque assignment
  deque<T>& operator=(const cppvmStlDeque<T>& obj){
    cppvmObject::operator=((const cppvmObject&) obj);
    return deque<T>::operator=((const deque<T>&) obj);
  }
  // deque assignment
  deque<T>& operator=(const deque<T>& obj){
    return deque<T>::operator=(obj);
  }

  // compare operators
  bool operator!=(const cppvmStlDeque<T>& obj) const {
    return !(operator==((const deque<T>&) *this, (const deque<T>&) obj));
  }
  bool operator==(const cppvmStlDeque& obj) {
    return operator==((const deque<T>&) *this, (const deque<T>&) obj);
  }
  bool operator==(const cppvmStlDeque& obj) const {
    return operator==((const deque<T>&) *this, (const deque<T>&) obj);
  }

  virtual void cppvmTransfer() {
    cppvmTransferStlDeque ( (deque<T>&) *this, 1);
  }
  
  CPPvmBuildInMsgTagMethodsStlDeclaration(CPPvmMsgTagClassStlDeque)
        
};

/*@@@**************************************************************************
**********                                                           **********
*******                       EXPORTED FUNCTIONS                        *******
**********                                                           **********
******************************************************************************/

// send cppvmStlDeque classes
template <class T>
inline cppvmSendStream&
operator<<(cppvmSendStream& sendStrm, cppvmStlDeque<T>& obj){
  obj.cppvmSend(sendStrm);
  return sendStrm;
}

// receive cppvmStlDeque classes
template <class T>
inline cppvmReceiveStream&
operator>>(cppvmReceiveStream& recStrm, cppvmStlDeque<T>& obj){
  // set the receive result in 'recStrm'
  recStrm.setLastRecResult(obj.cppvmReceive(recStrm));
  return recStrm;
}

#endif // CPPvmDoNotUseStl
#endif // CPPvmDoNotUseTemplates

#endif 
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/



