/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_stllist.h 
@SE  CREATED     : 31.1.2000
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : cppvm stl list class
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_STLLIST_INCLUDE
#define _PVM_STLLIST_INCLUDE

#ifndef CPPvmDoNotUseTemplates
#ifndef CPPvmDoNotUseStl

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_obj.h"
#include "pvm_stl.h"

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/

template <class T>
class cppvmStlList: public cppvmObject, public list<T> {
  
public:
  // common constructors
  cppvmStlList(): cppvmObject(), list<T>() {}
  cppvmStlList(typename list<T>::size_type n): cppvmObject(), list<T>(n) {}
  cppvmStlList(typename list<T>::size_type n, const T& value): 
      cppvmObject(), list<T>(n, value) {}
  cppvmStlList(typename list<T>::const_iterator first, 
               typename list<T>::const_iterator last): 
      cppvmObject(), list<T>(first, last) {}
  // constructors for cppvmStlList
  cppvmStlList(const cppvmStlList<T>& obj) : 
      cppvmObject(), list<T>((const list<T>&)obj){}
  // constructors for list
  cppvmStlList(const list<T>& obj) : 
      cppvmObject(), list<T>(obj) {}
  // destructor
  virtual ~cppvmStlList() {}
  
  // cppvmStlList assignment
  list<T>& operator=(const cppvmStlList<T>& obj){
    cppvmObject::operator=((const cppvmObject&) obj);
    return list<T>::operator=((const list<T>&) obj);
  }
  // list assignment
  list<T>& operator=(const list<T>& obj){
    return list<T>::operator=(obj);
  }

  // compare operators
  bool operator!=(const cppvmStlList<T>& obj) const {
    return !(operator==((const list<T>&) *this, (const list<T>&) obj));
  }
  bool operator==(const cppvmStlList& obj) {
    return operator==((const list<T>&) *this, (const list<T>&) obj);
  }
  bool operator==(const cppvmStlList& obj) const {
    return operator==((const list<T>&) *this, (const list<T>&) obj);
  }

  virtual void cppvmTransfer() {
    cppvmTransferStlList ( (list<T>&) *this, 1);
  }
  
  CPPvmBuildInMsgTagMethodsStlDeclaration(CPPvmMsgTagClassStlList)
        
};

/*@@@**************************************************************************
**********                                                           **********
*******                       EXPORTED FUNCTIONS                        *******
**********                                                           **********
******************************************************************************/

// send cppvmStlList classes
template <class T>
inline cppvmSendStream&
operator<<(cppvmSendStream& sendStrm, cppvmStlList<T>& obj){
  obj.cppvmSend(sendStrm);
  return sendStrm;
}

// receive cppvmStlList classes
template <class T>
inline cppvmReceiveStream&
operator>>(cppvmReceiveStream& recStrm, cppvmStlList<T>& obj){
  // set the receive result in 'recStrm'
  recStrm.setLastRecResult(obj.cppvmReceive(recStrm));
  return recStrm;
}

#endif // CPPvmDoNotUseStl
#endif // CPPvmDoNotUseTemplates

#endif 
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/



