/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_stlpair.h 
@SE  CREATED     : 25.07.2001
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : cppvm stl pair class
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_STLPAIR_INCLUDE
#define _PVM_STLPAIR_INCLUDE

#ifndef CPPvmDoNotUseTemplates
#ifndef CPPvmDoNotUseStl

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_obj.h"
#include "pvm_stl.h"

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/

template <class T1, class T2>
class cppvmStlPair: public cppvmObject, public pair<T1, T2> {
  
public:
  // common constructors
  cppvmStlPair(): cppvmObject(), pair<T1, T2>() {}
  cppvmStlPair(const T1& a, const T2& b) :
      cppvmObject(), pair<T1, T2>(a,b) {}
  // constructors for cppvmStlPair
  cppvmStlPair(const cppvmStlPair<T1, T2>& obj) : 
      cppvmObject(), pair<T1, T2>((const pair<T1, T2>&)obj){}
  // constructors for pair
  cppvmStlPair(const pair<T1, T2>& obj) : 
      cppvmObject(), pair<T1, T2>(obj) {}
  // destructor
  virtual ~cppvmStlPair() {}
  
  virtual void cppvmTransfer() {
    cppvmTransferStlPair ( (pair<T1, T2>&) *this, 1);
  }
  
  CPPvmBuildInMsgTagMethodsStlDeclaration(CPPvmMsgTagClassStlPair)
        
};


/*@@@**************************************************************************
**********                                                           **********
*******                       EXPORTED FUNCTIONS                        *******
**********                                                           **********
******************************************************************************/

template <class T1, class T2>
inline bool operator==(const cppvmStlPair<T1, T2>& x, 
                       const cppvmStlPair<T1, T2>& y)
{ 
  return (((const pair<T1, T2>&)x) == ((const pair<T1, T2>&)y));
}

template <class T1, class T2>
inline bool operator==(const pair<T1, T2>& x, 
                       const cppvmStlPair<T1, T2>& y)
{ 
  return x == ((const pair<T1, T2>&)y);
}

template <class T1, class T2>
inline bool operator==(const cppvmStlPair<T1, T2>& x, 
                       const pair<T1, T2>& y)
{ 
  return ((const pair<T1, T2>&)x) == y;
}

template <class T1, class T2>
inline bool operator<(const cppvmStlPair<T1, T2>& x, 
                      const cppvmStlPair<T1, T2>& y)
{ 
  return ((const pair<T1, T2>&)x) < ((const pair<T1, T2>&)y);
}

template <class T1, class T2>
inline bool operator<(const pair<T1, T2>& x, 
                      const cppvmStlPair<T1, T2>& y)
{ 
  return x < ((const pair<T1, T2>&)y);
}

template <class T1, class T2>
inline bool operator<(const cppvmStlPair<T1, T2>& x, 
                      const pair<T1, T2>& y)
{ 
  return ((const pair<T1, T2>&)x) < y;
}

// send cppvmStlPair classes
template <class T1, class T2>
inline cppvmSendStream&
operator<<(cppvmSendStream& sendStrm, cppvmStlPair<T1, T2>& obj){
  obj.cppvmSend(sendStrm);
  return sendStrm;
}

// receive cppvmStlPair classes
template <class T1, class T2>
inline cppvmReceiveStream&
operator>>(cppvmReceiveStream& recStrm, cppvmStlPair<T1, T2>& obj){
  // set the receive result in 'recStrm'
  recStrm.setLastRecResult(obj.cppvmReceive(recStrm));
  return recStrm;
}

#endif // CPPvmDoNotUseStl
#endif // CPPvmDoNotUseTemplates

#endif 
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/



