/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_stlslist.h 
@SE  CREATED     : 31.1.2000
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : cppvm stl slist class
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_STLSLIST_INCLUDE
#define _PVM_STLSLIST_INCLUDE

#ifdef CPPvmUseStlSlist

#ifndef CPPvmDoNotUseTemplates
#ifndef CPPvmDoNotUseStl

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_obj.h"
#include "pvm_stl.h"

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/

template <class T>
class cppvmStlSlist: public cppvmObject, public slist<T> {
  
public:
  // common constructors
  cppvmStlSlist(): cppvmObject(), slist<T>() {}
  cppvmStlSlist(typename slist<T>::size_type n): cppvmObject(), slist<T>(n) {}
  cppvmStlSlist(typename slist<T>::size_type n, const T& value): 
      cppvmObject(), slist<T>(n, value) {}
  cppvmStlSlist(typename slist<T>::const_iterator first, 
                typename slist<T>::const_iterator last): 
      cppvmObject(), slist<T>(first, last) {}
  // constructors for cppvmStlSlist
  cppvmStlSlist(const cppvmStlSlist<T>& obj) : 
      cppvmObject(), slist<T>((const slist<T>&)obj){}
  // constructors for slist
  cppvmStlSlist(const slist<T>& obj) : 
      cppvmObject(), slist<T>(obj) {}
  // destructor
  virtual ~cppvmStlSlist() {}
  
  // cppvmStlSlist assignment
  slist<T>& operator=(const cppvmStlSlist<T>& obj){
    cppvmObject::operator=((const cppvmObject&) obj);
    return slist<T>::operator=((const slist<T>&) obj);
  }
  // slist assignment
  slist<T>& operator=(const slist<T>& obj){
    return slist<T>::operator=(obj);
  }

  // compare operators
  bool operator!=(const cppvmStlSlist<T>& obj) const {
    return !(operator==((const slist<T>&) *this, (const slist<T>&) obj));
  }
  bool operator==(const cppvmStlSlist& obj) {
    return operator==((const slist<T>&) *this, (const slist<T>&) obj);
  }
  bool operator==(const cppvmStlSlist& obj) const {
    return operator==((const slist<T>&) *this, (const slist<T>&) obj);
  }

  virtual void cppvmTransfer() {
    cppvmTransferStlSlist ( (slist<T>&) *this, 1);
  }
  
  CPPvmBuildInMsgTagMethodsStlDeclaration(CPPvmMsgTagClassStlSlist)
        
};

/*@@@**************************************************************************
**********                                                           **********
*******                       EXPORTED FUNCTIONS                        *******
**********                                                           **********
******************************************************************************/

// send cppvmStlSlist classes
template <class T>
inline cppvmSendStream&
operator<<(cppvmSendStream& sendStrm, cppvmStlSlist<T>& obj){
  obj.cppvmSend(sendStrm);
  return sendStrm;
}

// receive cppvmStlSlist classes
template <class T>
inline cppvmReceiveStream&
operator>>(cppvmReceiveStream& recStrm, cppvmStlSlist<T>& obj){
  // set the receive result in 'recStrm'
  recStrm.setLastRecResult(obj.cppvmReceive(recStrm));
  return recStrm;
}

#endif // CPPvmDoNotUseStl
#endif // CPPvmDoNotUseTemplates


#endif // CPPvmUseStlSlist

#endif 
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/



