/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_task.h 
@SE  CREATED     : 6.2.1998
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : pvm task description class
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : IMPORTANT: Multicasted (array of tids) and broadcasted
@SR                           (to group members) messages are NOT send to
@SR                           the caller even if the caller is in the
@SR                           array of tids resp. member of the group
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_TASK_INCLUDE
#define _PVM_TASK_INCLUDE


/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_obj.h"
#include "pvm_str.h"

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/


/*@@*****************************   CLASS   ***********************************
***
@KN  CLASS NAME    : cppvmTask
@KB  BASE CLASS    :
@KA  AUTHOR        : goerzig
@K#  
@KD  DESCRIPTION   : Pvm class
@KC  CONSTRAINTS   : 
******************************************************************************/
class cppvmTask : public cppvmObject {
 
public:
  cppvmTask();
  cppvmTask(int tid_,
          int contextId_,
          cppvmString name_);
  cppvmTask(const cppvmTask&);
  virtual ~cppvmTask();

  cppvmTask& operator=(const cppvmTask&);
  bool operator==(const cppvmTask&);
  bool operator==(const cppvmTask&) const;
  bool operator!=(const cppvmTask& obj) const {
    return ! (operator==(obj));
  }
  
  virtual void cppvmPrintOn(ostream& = cout);
  virtual void cppvmScanFrom(istream& = cin) {}

  CPPvmBuildInMsgTagMethodsDeclaration(CPPvmMsgTagClassTask)

  virtual void cppvmTransfer();

  int getTid(){return tid;}
  void setTid(int tid_){tid = tid_;}
  int getContextId(){return contextId;}
  void setContextId(int contextId_){contextId = contextId_;}
  cppvmString getName(){return name;}
  void setName(cppvmString name_){name = name_;}
  
  void killTask();
  void halt();
   
protected:
  int tid;
  cppvmString name;
  int contextId;
};

#endif
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/

