/*@@@**************************************************************************
**********                                                           **********
*******                      SPECIFICATION FILE                         *******
**********                                                           **********
*******************************************************************************
@SF  FILE        : pvm_tran.h 
@SE  CREATED     : 10.12.1999
@SA  AUTHOR      : goerzig
@SJ  PROJECT     : cppvm
@S#  
@SD  DESCRIPTION : CPPvm transfer functions
@SU  USAGE       : 
@SC  CONSTRAINTS : 
@S#  
@SR  NOTES       : 
@S#  --------------------------------------------------------------------------
@S#  Technical Information:
@S#  
@SI  LANGUAGE        : C++
@SI  HARDWARE        : PC 386
@SI  COMPILER        : gcc version 2.7.2.3
@SI  OPERATINGSYSTEM : Linux
@S#  --------------------------------------------------------------------------
@S#  Version Manager Informations:
@S#  
@SV  FILENAME    : $Source: $
@SV  AUTHOR      : $Author: $
@SV  REVISION    : $Revision: $
@SV  DATE        : $Date: $
@SV  STATE       : $State: $
@SV  LOCKER      : $Locker: $
@S#  
@SV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

#ifndef _PVM_TRAN_INCLUDE
#define _PVM_TRAN_INCLUDE

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                             CLASSES                             *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                            FUNCTIONS                            *******
**********                                                           **********
******************************************************************************/

// for common use
bool cppvmIsTransferReceive();
bool cppvmIsTransferSend();

void cppvmTransferFSend(char *ptr, ...);
void cppvmTransferFReceive(char *ptr, ...);

void cppvmTransferBool(bool *ptr, int nitem = 1, int stride = 1);
void cppvmTransferByte(char *ptr, int nitem = 1, int stride = 1);
void cppvmTransferCplx(float *ptr, int nitem = 1, int stride = 1);
void cppvmTransferDcplx(double *ptr, int nitem = 1, int stride = 1);
void cppvmTransferDouble(double *ptr, int nitem = 1, int stride = 1);
void cppvmTransferFloat(float *ptr, int nitem = 1, int stride = 1);
void cppvmTransferInt(int *ptr, int nitem = 1, int stride = 1);
void cppvmTransferUint(unsigned int *ptr, int nitem = 1, int stride = 1);
void cppvmTransferUshort(unsigned short *ptr, int nitem = 1, int stride = 1);
void cppvmTransferUlong(unsigned long *ptr, int nitem = 1, int stride = 1);
void cppvmTransferLong(long *ptr, int nitem = 1, int stride = 1);
void cppvmTransferShort(short *ptr, int nitem = 1, int stride = 1);
void cppvmTransferStr(char *ptr);

#ifndef CPPvmDoNotUseTemplates
// classes derived from 'cppvmObject'
template<class T>
inline
void
cppvmTransferTemplate(T* data, int nitem, int stride)
{
  int i;
  for(i=0;i<nitem;i++){
    data[i].cppvmTransfer();
  }
}

template<class T>
inline
void
cppvmTransferTemplate(T& data, int stride)
{
  data.cppvmTransfer();
}


template<>
void
cppvmTransferTemplate(bool* data, int nitem, int stride);
template<>
void
cppvmTransferTemplate(bool& data, int stride);
template<>
void
cppvmTransferTemplate(char* data, int nitem, int stride);
template<>
void
cppvmTransferTemplate(char& data, int stride);
template<>
void
cppvmTransferTemplate(int* data, int nitem, int stride);
template<>
void
cppvmTransferTemplate(int& data, int stride);
template<>
void
cppvmTransferTemplate(short* data, int nitem, int stride);
template<>
void
cppvmTransferTemplate(short& data, int stride);
template<>
void
cppvmTransferTemplate(long* data, int nitem, int stride);
template<>
void
cppvmTransferTemplate(long& data, int stride);
template<>
void
cppvmTransferTemplate(unsigned int* data, int nitem, int stride);
template<>
void
cppvmTransferTemplate(unsigned int& data, int stride);
template<>
void
cppvmTransferTemplate(unsigned short* data, int nitem, int stride);
template<>
void
cppvmTransferTemplate(unsigned short& data, int stride);
template<>
void
cppvmTransferTemplate(unsigned long* data, int nitem, int stride);
template<>
void
cppvmTransferTemplate(unsigned long& data, int stride);
template<>
void
cppvmTransferTemplate(float* data, int nitem, int stride);
template<>
void
cppvmTransferTemplate(float& data, int stride);
template<>
void
cppvmTransferTemplate(double* data, int nitem, int stride);
template<>
void
cppvmTransferTemplate(double& data, int stride);

#endif // CPPvmDoNotUseTemplates


#endif 
/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/




