/*@@@**************************************************************************
**********                                                           **********
*******                      IMPLEMENTATION FILE                        *******
**********                                                           **********
*******************************************************************************
@IF  FILE        : pvm_arda.cpp 
@IE  CREATED     : 3.2.1998
@IA  AUTHOR      : goerzig
@IJ  PROJECT     : cppvm
@I#  
@ID  DESCRIPTION : pvm array data base class
@IU  USAGE       : 
@IC  CONSTRAINTS : 
@I#  
@IR  NOTES       : 
@I#  --------------------------------------------------------------------------
@I#  Technical Information:
@I#  
@II  LANGUAGE        : C++
@II  HARDWARE        : PC 386
@II  COMPILER        : gcc version 2.7.2.3
@II  OPERATINGSYSTEM : Linux
@I#  --------------------------------------------------------------------------
@I#  Version Manager Informations:
@I#  
@IV  FILENAME    : $Source: $
@IV  AUTHOR      : $Author: $
@IV  REVISION    : $Revision: $
@IV  DATE        : $Date: $
@IV  STATE       : $State: $
@IV  LOCKER      : $Locker: $
@I#  
@IV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_arda.h"


/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/
#define THIS_MODULE "pvm_arda.cpp"

/*@@@**************************************************************************
**********                                                           **********
*******                           VARIABLES                             *******
**********                                                           **********
******************************************************************************/
CPPvmBuildInMsgTagMethodsDefinition(cppvmArrayData,
                                      CPPvmMsgTagClassArrayData)

/*@@@**************************************************************************
**********                                                           **********
*******                             METHODS                             *******
**********                                                           **********
******************************************************************************/

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmArrayData
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmArrayData
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : len_   array length
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmArrayData::cppvmArrayData(unsigned int len_)
    : cppvmType(), cppvmTransferMode(CPPvmTransferModeClean),
      size(0), fitSizeToLength(false)
{
  len = (int) len_;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmArrayData
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : copy constructor
@MU  USAGE         : =
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj   object to copy
@MP  INOUT   : - 
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmArrayData::cppvmArrayData (const cppvmArrayData& obj)
    : cppvmType(obj), 
      cppvmTransferMode(CPPvmTransferModeClean),
      size(0), fitSizeToLength(false)
{
  len = obj.len;                // copy array length
}


/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : ~cppvmArrayData
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : destructor
@MU  USAGE         : ~cppvmArrayData
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmArrayData::~cppvmArrayData()
{
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator=
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : assignment
@MU  USAGE         : =
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object to assign
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmArrayData&
cppvmArrayData::operator=(const cppvmArrayData& obj)
{
  if(cppvmIsSame(obj)){
    return *this;
  }
  cppvmType::operator=(obj);
  
  len = obj.len; // copy array length
  //cppvmTransferMode = obj.cppvmTransferMode;
  //fitSizeToLength = obj.fitSizeToLength;
  
  return *this;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator==
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : equality
@MU  USAGE         : ==
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object to test
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
bool
cppvmArrayData::operator== (const cppvmArrayData& obj)
{
  return (len==obj.len);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator==
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : equality
@MU  USAGE         : ==
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object to test
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
bool
cppvmArrayData::operator== (const cppvmArrayData& obj) const
{
  return (len==obj.len);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : add
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : add the elements of two arrays
@MU  USAGE         : +
@MC  CONSTRAINTS   : only possible if the dimension of the arrays ('len')
@MC                  are the same
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object to add
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmArrayData&
cppvmArrayData::add(cppvmArrayData& obj) 
{
  if(len!=obj.len){
    CPPvmInternalThrow( cppvmExceptionOutOfRange(THIS_MODULE,
                                   "cppvmArrayData",
                                    "add",
                                    "dimesions (array lengths) are not the same"));
  }
  int i;

  for(i=0;i<len;i++){
    addElem(i, obj, i);
  }

  return *this;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : subtract
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : subtract the elements of two arrays
@MU  USAGE         : -
@MC  CONSTRAINTS   : only possible if the dimension of the arrays ('len')
@MC                  are the same
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object to subtract
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmArrayData&
cppvmArrayData::subtract(cppvmArrayData& obj) 
{
  if(len!=obj.len){
    CPPvmInternalThrow( cppvmExceptionOutOfRange(THIS_MODULE,
                                 "cppvmArrayData",
                                 "subtract",
                                 "dimesions (array lengths) are not the same"));
  }
  int i;

  for(i=0;i<len;i++){
    subElem(i, obj, i);
  }

  return *this;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : multiply
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : multiply the elements of two arrays
@MU  USAGE         : -
@MC  CONSTRAINTS   : only possible if the dimension of the arrays ('len')
@MC                  are the same
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object to multiply
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmArrayData&
cppvmArrayData::multiply(cppvmArrayData& obj) 
{
  if(len!=obj.len){
    CPPvmInternalThrow( cppvmExceptionOutOfRange(THIS_MODULE,
                                 "cppvmArrayData",
                                 "multiply",
                                 "dimesions (array lengths) are not the same"));
  }
  int i;

  for(i=0;i<len;i++){
    multElem(i, obj, i);
  }

  return *this;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : divide
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : divide the elements of two arrays
@MU  USAGE         : -
@MC  CONSTRAINTS   : only possible if the dimension of the arrays ('len')
@MC                  are the same
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object to divide
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmArrayData&
cppvmArrayData::divide(cppvmArrayData& obj) 
{
  if(len!=obj.len){
    CPPvmInternalThrow( cppvmExceptionOutOfRange(THIS_MODULE,
                                 "cppvmArrayData",
                                 "divide",
                                 "dimesions (array lengths) are not the same"));
  }
  int i;

  for(i=0;i<len;i++){
    divElem(i, obj, i);
  }

  return *this;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator++
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : increment prefix operator
@MD                  increment every array element
@MU  USAGE         : ++
@MC  CONSTRAINTS   : 
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : -
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
void
cppvmArrayData::operator++()
{
  int i;
  for(i=0;i<len;i++){
    incElemPrae(i);
  }
}
/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator++
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : increment postfix operator
@MD                  increment every array element
@MU  USAGE         : ++
@MC  CONSTRAINTS   : 
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : -
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
void
cppvmArrayData::operator++(int)
{
  int i;
  for(i=0;i<len;i++){
    incElemPost(i);
  }
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator--
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : decrement prefix operator
@MD                  decrement every array element
@MU  USAGE         : --
@MC  CONSTRAINTS   : 
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : -
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
void
cppvmArrayData::operator--()
{
  int i;
  for(i=0;i<len;i++){
    decElemPrae(i);
  }
}
/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator--
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : decrement postfix operator
@MD                  decrement every array element
@MU  USAGE         : --
@MC  CONSTRAINTS   : 
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : -
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
void
cppvmArrayData::operator--(int)
{
  int i;
  for(i=0;i<len;i++){
    decElemPost(i);
  }
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmTransfer
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : transfer object from/to buffer
@MU  USAGE         : cppvmTransfer()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmArrayData::cppvmTransfer()
{
  // transfer base class variables
  cppvmType::cppvmTransfer();

}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : setPvmTansferMode
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : set the pvm transfer mode of this object
@MU  USAGE         : setCPPvmTransferMode()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmArrayData::setCPPvmTransferMode(int mode)
{
  if(mode!=CPPvmTransferModeClean &&
     mode!=CPPvmTransferModeAppend){
    CPPvmInternalThrow( cppvmExceptionBadParameter(THIS_MODULE,
                                                   "cppvmArrayData",
                                                   "setCPPvmTransferMode",
                                                   "unknown transfer mode"));
  }
  cppvmTransferMode = mode;
}


/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmPrintOn
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : print method for << operator
@MU  USAGE         : cppvmPrintOn()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : strm  stream to print object on
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmArrayData::cppvmPrintOn(ostream& strm)
{
  strm << len;
  strm << " ";
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmScanFrom
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : scan method for << operator
@MU  USAGE         : cppvmScanFrom()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : strm  stream to scan object from
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmArrayData::cppvmScanFrom(istream& strm)
{
  strm >> len;
}


/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : append
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : append an array to another one
@MU  USAGE         : void append(const cppvmArrayData& obj)
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : obj   array to append 
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmArrayData::append(cppvmArrayData& obj)
{
  int tmpLen;
  int sumLen;
  int diffLen;

  // remind old length
  tmpLen = len;
  // new length
  sumLen = len + obj.len;

  // resize array
  resize(sumLen);
  
  diffLen = sumLen - tmpLen;
  if(diffLen>0){
    // copy 'diffLen' elements beginning from obj.array[0] to array[tmpLen]
    copyElems(diffLen, tmpLen, obj, 0);
  }
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : setFitSizeToLength
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : fit the array size to the current length
@MU  USAGE         : void setFitSizeToLength(bol value);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         : 
@M#  --------------------------------------------------------------------------
@MP  IN      : value  true: whenever a new or delete of a the string
@MP                         is needed, the string size is fitted to the
@MP                         string length
@MP                   false: the size can only get bigger, not smaller     
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmArrayData::setFitSizeToLength(bool value)
{
  fitSizeToLength = value;
  if(fitSizeToLength){
    // fit the size to the length
    resize(len);
  }
  
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : resize
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : resize the array to a new length
@MD                  copy old values if possible
@MD                  'fitSizeToLength' == true: allocate new array if
@MD                                             if newLen!=size+1
@MD                  'fitSizeToLength' == false: allocate new array if
@MD                                              newLen+1>size
@@MU  USAGE         : void resize(unsigned int newLen)
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         : the class variables 'len' and 'size' must have
@MR                  correct values, 'array' can be NULL
@M#  --------------------------------------------------------------------------
@MP  IN      : newLen  new length of the array
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmArrayData::resize(unsigned int newLen)
{
  resizeWithoutFill(newLen);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : resizeClean
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : resize array length; clean array
@MD                  'fitSizeToLength' == true: allocate new array if
@MD                                             if newSize!=size+1
@MD                  'fitSizeToLength' == false: allocate new array if
@MD                                              newSize+1>size
@MU  USAGE         : resizeClean(unsigned int newSize,
@MU                              bool cleanOnlyNewElements)
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         : the class variables 'len' and 'size' must have
@MR                  correct values, 'array' can be NULL
@M#  --------------------------------------------------------------------------
@MP  IN      : newSize              new array size
@MP            cleanOnlyNewElements do not clean the complete array
@MP                                 but only new elements if the array
@MP                                 gets larger
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmArrayData::resizeClean(unsigned int newSize,
                            bool cleanOnlyNewElements)
{
  unsigned int oldLen = (unsigned int)len;

  if(cleanOnlyNewElements){
    resizeWithoutFill(newSize);
    if(oldLen<newSize){
      // clean only new elements
      cleanRange(oldLen, newSize-1);
    }
  }
  else{
    resizeWithoutFillAndCopy(newSize);
    // 'clean' array
    if(newSize>0){
      cleanRange(0, newSize-1);
    }
  }
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : checkCleanRange
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : check for the requested range to be in the array
@MU  USAGE         : checkCleanRange(unsigned int fromIndex, unsigned int toIndex)
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         : the class variables 'len' and 'size' must have
@MR                  correct values, 'array' must not be NULL
@M#  --------------------------------------------------------------------------
@MP  IN      : fromIndex    index of first element to clean
@MP            toIndex      index of last element to clean
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmArrayData::checkCleanRange(unsigned int fromIndex,
                                unsigned int toIndex)
{
  if(fromIndex>toIndex){
    CPPvmInternalThrow( cppvmExceptionOutOfRange(THIS_MODULE,
                                                 "cppvmArrayData",
                                                 "checkCleanRange",
                                                 "'fromIndex' is greater than 'toIndex'"));
  }
  if(fromIndex>=(unsigned int)len){
    CPPvmInternalThrow( cppvmExceptionOutOfRange(THIS_MODULE,
                                                 "cppvmArrayData",
                                                 "checkCleanRange",
                                                 "'fromIndex' is greater than array length"));
  }
  if(toIndex>=(unsigned int)len){
    CPPvmInternalThrow( cppvmExceptionOutOfRange(THIS_MODULE,
                                                 "cppvmArrayData",
                                                 "checkCleanRange",
                                                 "'toIndex' is greater than array length"));
  }
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : resizeWithoutFill
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : resize array length without filling
@MD                  new allocated chars with ' '
@MD                  copy old values if possible
@MD                  'fitSizeToLength' == true: allocate new array if
@MD                                             if newLen!=size+1
@MD                  'fitSizeToLength' == false: allocate new array if
@MD                                              newLen+1>size
@MU  USAGE         : void resizeWithoutFill(unsignd int newLen)
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         : the class variables 'len' and 'size' must have
@MR                  correct values, 'array' can be NULL
@M#  --------------------------------------------------------------------------
@MP  IN      : newLen  new array length
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmArrayData::resizeWithoutFill(unsigned int newLen)
{
  if(arrayIsNULL()==true){
    size = (int)newLen;
    len = size;
    // allocate memory if there is no array
    newArray(newLen);
    return;
  }

  if(((int)newLen==len) && (!fitSizeToLength)){
    // the array has the correct length
    // and must not be fitted to the
    // current size
    // do nothing
    return;
  }
  if(((int)newLen==len) && len==size){
    // the array has the correct length
    // and the length is fitted to the
    // current size
    // do nothing
    return;
  }

  if((!fitSizeToLength) && ((int)newLen <= size)){
    // do not fit the size of the array
    // and the old size is big enough
    // just set new length
    len = (int)newLen;
    return;
  }
  
  // new array is needed
  unsigned int maxLen;
    
  if(len>=(int)newLen){
    maxLen=newLen;
  }
  else{
    maxLen=(unsigned int)len;
  }
  
  size = (int)newLen;
  len = size;
  newArrayCopy(newLen, maxLen);

}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : resizeWithoutFillAndCopy
@MK  CLASS NAME    : cppvmArrayData
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : resize array size without filling
@MD                  new allocated chars with ' ' and without
@MD                  copying old values
@MD                  'fitSizeToLength' == true: allocate new array if
@MD                                             if newLen!=size+1
@MD                  'fitSizeToLength' == false: allocate new array if
@MD                                              newLen+1>size
@MU  USAGE         : void resizeWithoutFillAndCopy(unsignd int newLen)
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         : the class variables 'len' and 'size' must have
@MR                  correct values, 'array' can be NULL
@M#  --------------------------------------------------------------------------
@MP  IN      : newLen  new array length
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmArrayData::resizeWithoutFillAndCopy(unsigned int newLen)
{
  if(arrayIsNULL()==true){
    size = (int)newLen;
    len = size;
    // allocate memory if there is no array
    newArray(newLen);
    return;
  }

  if(((int)newLen==len) && (!fitSizeToLength)){
    // the array has the correct length
    // and must not be fitted to the
    // current size
    // do nothing
    return;
  }
  if(((int)newLen==len) && len==size){
    // the array has the correct length
    // and the length is fitted to the
    // current size
    // do nothing
    return;
  }

  if((!fitSizeToLength) && ((int)newLen <= size)){
    // do not fit the size of the array
    // and the old size is big enough
    // just set new length
    len = (int)newLen;
    return;
  }
  
  // the former array is not needed any more
  size = (int)newLen;
  len = size;
  newArray(newLen);

}

/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/

