/*@@@**************************************************************************
**********                                                           **********
*******                      IMPLEMENTATION FILE                        *******
**********                                                           **********
*******************************************************************************
@IF  FILE        : pvm_cose.cpp 
@IE  CREATED     : 18.2.1999
@IA  AUTHOR      : goerzig
@IJ  PROJECT     : cppvm
@I#  
@ID  DESCRIPTION : complex semaphore class for semaphore server
@IU  USAGE       : 
@IC  CONSTRAINTS : 
@I#  
@IR  NOTES       : 
@I#  --------------------------------------------------------------------------
@I#  Technical Information:
@I#  
@II  LANGUAGE        : C++
@II  HARDWARE        : PC 386
@II  COMPILER        : gcc version 2.7.2.3
@II  OPERATINGSYSTEM : Linux
@I#  --------------------------------------------------------------------------
@I#  Version Manager Informations:
@I#  
@IV  FILENAME    : $Source: $
@IV  AUTHOR      : $Author: $
@IV  REVISION    : $Revision: $
@IV  DATE        : $Date: $
@IV  STATE       : $State: $
@IV  LOCKER      : $Locker: $
@I#  
@IV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
// include standard CPPvm classes
#include "pvm_str.h"
#include "pvm_int.h"
#include "pvm_coll.h"
// include class description
#include "pvm_cose.h"


/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/
#define THIS_MODULE "pvm_cose.cpp"

/*@@@**************************************************************************
**********                                                           **********
*******                           VARIABLES                             *******
**********                                                           **********
******************************************************************************/
CPPvmBuildInMsgTagMethodsDefinition(cppvmComplexSemaphore,
                                    CPPvmMsgTagClassComplexSemaphore)

/*@@@**************************************************************************
**********                                                           **********
*******                             METHODS                             *******
**********                                                           **********
******************************************************************************/

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmComplexSemaphore
@MK  CLASS NAME    : cppvmComplexSemaphore
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmComplexSemaphore(cppvmString semaName)
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : semaName  key name for semaphore
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmComplexSemaphore::cppvmComplexSemaphore(cppvmString semaName) 
    : cppvmObject()
{
  semaNumber=0;
  complexSemaName = semaName;
  firstSetNumberCall = true;
  
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmComplexSemaphore
@MK  CLASS NAME    : cppvmComplexSemaphore
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : copy constructor
@MU  USAGE         : =
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj   object to copy
@MP  INOUT   : - 
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmComplexSemaphore::cppvmComplexSemaphore (const cppvmComplexSemaphore& obj)
    : cppvmObject(obj)
{
}


/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : ~cppvmComplexSemaphore
@MK  CLASS NAME    : cppvmComplexSemaphore
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : destructor
@MU  USAGE         : ~cppvmComplexSemaphore
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmComplexSemaphore::~cppvmComplexSemaphore()
{
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator=
@MK  CLASS NAME    : cppvmComplexSemaphore
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : assignment
@MU  USAGE         : =
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object to assign
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmComplexSemaphore&
cppvmComplexSemaphore::operator=(const cppvmComplexSemaphore& obj)
{
  if(cppvmIsSame(obj)){
    return *this;
  }
  cppvmObject::operator=(obj);
  
  return *this;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator==
@MK  CLASS NAME    : cppvmComplexSemaphore
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : equality
@MU  USAGE         : ==
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object to test
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
bool
cppvmComplexSemaphore::operator== (const cppvmComplexSemaphore& obj)
{
  return (complexSemaName==obj.complexSemaName);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator==
@MK  CLASS NAME    : cppvmComplexSemaphore
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : equality
@MU  USAGE         : ==
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object to test
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
bool
cppvmComplexSemaphore::operator== (const cppvmComplexSemaphore& obj) const
{
  return (complexSemaName==obj.complexSemaName);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmTransfer
@MK  CLASS NAME    : cppvmComplexSemaphore
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : transfer object from/to buffer
@MU  USAGE         : cppvmTransfer()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmComplexSemaphore::cppvmTransfer()
{
  semaNumber.cppvmTransfer();
  complexSemaName.cppvmTransfer();
  queueTidList.cppvmTransfer();
}


/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmPrintOn
@MK  CLASS NAME    : cppvmComplexSemaphore
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : print method for << operator
@MU  USAGE         : cppvmPrintOn()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : strm  stream to print object on
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmComplexSemaphore::cppvmPrintOn(ostream& strm)
{
  strm << "cppvmComplexSemaphore"
       << " name: " << complexSemaName 
       << " number: " << semaNumber
       << " tid-queue: " << queueTidList
       << endl;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmScanFrom
@MK  CLASS NAME    : cppvmComplexSemaphore
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : scan method for << operator
@MU  USAGE         : cppvmScanFrom()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : strm  stream to scan object from
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmComplexSemaphore::cppvmScanFrom(istream& /*strm*/)
{
}


/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : addToList
@MK  CLASS NAME    : cppvmComplexSemaphore
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : add a given tid to the list
@MU  USAGE         : void addToList(int tid);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : tid  task id of a waiting process
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmComplexSemaphore::addToList(int tid)
{
  queueTidList.add((cppvmObject*) new cppvmInt(tid));
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : getAndRemoveTidFromList
@MK  CLASS NAME    : cppvmComplexSemaphore
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : get the oldest (first) tid in the list and remove it
@MD                  from the list
@MU  USAGE         : int getAndRemoveTidFromList()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : int >=0: task id of waiting process
@MP                < 0: no waiting process
******************************************************************************/
int
cppvmComplexSemaphore::getAndRemoveTidFromList()
{
  if(queueTidList.numElems()==0){
    // no waiting process
    return -1;
  }
  int tid;

  // get first element in list
  tid = (int)((cppvmInt&)(queueTidList[0]));
  queueTidList.remove((unsigned int)0);
  
  return tid;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : setNumber
@MK  CLASS NAME    : cppvmComplexSemaphore
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : set new number of semaphores
@MD                  can only be set ONE time!
@MU  USAGE         : bool setMaxNumber(unsigned int newNumber);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : newNumber wanted new number of semaphores
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : bool: true:  value set
@MP                  false: value was set before
******************************************************************************/
bool
cppvmComplexSemaphore::setNumber(unsigned int newNumber)
{
  if(firstSetNumberCall == true){
    firstSetNumberCall = false;
    semaNumber = (cppvmInt)((int)(newNumber));
    return true;
  }
  else{
    return false;
  }
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : enter
@MK  CLASS NAME    : cppvmComplexSemaphore
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : semaphore enter
@MD                  true:  enter allowed, increase current enter number
@MD                  false: no more enters possible, add process tid to 
@MD                         waiting queue
@MU  USAGE         : bool enter(int tid);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : tid   task id of the asking process
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : true:  enter allowed, send OK to asking process
@MP            false: enter not allowed, added tid to queue
******************************************************************************/
bool
cppvmComplexSemaphore::enter(int tid)
{
  if((int) semaNumber==0){
    // enter not allowed, all places occupied
    // remind task id
    addToList(tid);
    return false;
  }
  else{
    // enter allowed
    semaNumber--;
    return true;
  }
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : enterNB
@MK  CLASS NAME    : cppvmComplexSemaphore
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : non-blocking semaphore enter
@MD                  true:  enter allowed, increase current enter number
@MD                  false: no more enters possible, do NOT add process tid to 
@MD                         waiting queue
@MU  USAGE         : bool enterNB();
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : true:  enter allowed, send OK to asking process
@MP            false: enter not allowed
******************************************************************************/
bool
cppvmComplexSemaphore::enterNB()
{
  if((int) semaNumber==0){
    // enter not allowed, all places occupied
    return false;
  }
  else{
    // enter allowed
    semaNumber--;
    return true;
  }
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : leave
@MK  CLASS NAME    : cppvmComplexSemaphore
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : semaphore leave
@MD                  < 0: no waiting process
@MD                  >=0: task id of a waiting process
@MU  USAGE         : int leave();
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : int < 0: no waiting process
@MP                >=0: task id of a waiting process
******************************************************************************/
int
cppvmComplexSemaphore::leave()
{
  int tid;
  
  tid=getAndRemoveTidFromList();
  if(tid<0){
    // no waiting processes
    semaNumber++;
    return -1;
  }
  else{
    return tid;
  }
}

/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/

