/*@@@**************************************************************************
**********                                                           **********
*******                      IMPLEMENTATION FILE                        *******
**********                                                           **********
*******************************************************************************
@IF  FILE        : pvm_exre.cpp 
@IE  CREATED     : 5.12.1997
@IA  AUTHOR      : goerzig
@IJ  PROJECT     : cppvm
@I#  
@ID  DESCRIPTION : bad result class for exception handling
@IU  USAGE       : 
@IC  CONSTRAINTS : 
@I#  
@IR  NOTES       : 
@I#  --------------------------------------------------------------------------
@I#  Technical Information:
@I#  
@II  LANGUAGE        : C++
@II  HARDWARE        : PC 386
@II  COMPILER        : gcc version 2.7.2.3
@II  OPERATINGSYSTEM : Linux
@I#  --------------------------------------------------------------------------
@I#  Version Manager Informations:
@I#  
@IV  FILENAME    : $Source: $
@IV  AUTHOR      : $Author: $
@IV  REVISION    : $Revision: $
@IV  DATE        : $Date: $
@IV  STATE       : $State: $
@IV  LOCKER      : $Locker: $
@I#  
@IV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_exre.h"

/*@@@**************************************************************************
**********                                                           **********
*******                             METHODS                             *******
**********                                                           **********
******************************************************************************/

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : ~cppvmExceptionBadResult
@MK  CLASS NAME    : cppvmExceptionBadResult
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : destructor 
@MU  USAGE         : ~cppvmExceptionBadResult
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : cppvmExceptionBadResult
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmExceptionBadResult::~cppvmExceptionBadResult () 
{
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator=
@MK  CLASS NAME    : cppvmExceptionBadResult
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : assignment
@MU  USAGE         : =
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object which has to be assigned to the local object
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmExceptionBadResult& 
cppvmExceptionBadResult::operator= (const cppvmExceptionBadResult& obj)
{
  if(this == &obj){
    return *this;
  }
  cppvmException::operator=(obj);
  return *this;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator==
@MK  CLASS NAME    : cppvmExceptionBadResult
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : test equality
@MU  USAGE         : ==
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  obj which has to be assigned to the local object
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
bool
cppvmExceptionBadResult::operator== (const cppvmExceptionBadResult& obj)
{
  return ( cppvmException(obj) == cppvmException(*this));
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator==
@MK  CLASS NAME    : cppvmExceptionBadResult
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : test equality
@MU  USAGE         : ==
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object which has to be tested
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
bool
cppvmExceptionBadResult::operator== (const cppvmExceptionBadResult& obj) const
{
  return ( cppvmException(obj) == cppvmException(*this));
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmExceptionBadResult
@MK  CLASS NAME    : cppvmExceptionBadResult
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : copy constructor
@MU  USAGE         : =
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj   object to copy
@MP  INOUT   : - 
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmExceptionBadResult::cppvmExceptionBadResult (const cppvmExceptionBadResult& obj)
    : cppvmException(obj)
{
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : printOn
@MK  CLASS NAME    : cppvmExceptionBadResult
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : print method for << operator
@MU  USAGE         : printOn()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : strm  stream to print object on
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmExceptionBadResult::printOn(ostream& strm)
{
#ifdef CPPvmErrorMsg
  strm <<
    "BadResult Exception:" << endl <<
    "Module:          " << module_name << endl <<
    "Class:           " << class_name  << endl <<
    "Method/Function: " << method_name << endl <<
    "Error:           " << err_msg     << endl;
#endif
}

/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/

