/*@@@**************************************************************************
**********                                                           **********
*******                      IMPLEMENTATION FILE                        *******
**********                                                           **********
*******************************************************************************
@IF  FILE        : pvm_globvar.cpp 
@IE  CREATED     : 17.10.2001
@IA  AUTHOR      : goerzig
@IJ  PROJECT     : cppvm
@I#  
@ID  DESCRIPTION : class for global variables
@IU  USAGE       : 
@IC  CONSTRAINTS : 
@I#  
@IR  NOTES       : 
@I#  --------------------------------------------------------------------------
@I#  Technical Information:
@I#  
@II  LANGUAGE        : C++
@II  HARDWARE        : PC 386
@II  COMPILER        : gcc version 2.7.2.3
@II  OPERATINGSYSTEM : Linux
@I#  --------------------------------------------------------------------------
@I#  Version Manager Informations:
@I#  
@IV  FILENAME    : $Source: $
@IV  AUTHOR      : $Author: $
@IV  REVISION    : $Revision: $
@IV  DATE        : $Date: $
@IV  STATE       : $State: $
@IV  LOCKER      : $Locker: $
@I#  
@IV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_globvar.h"

/*@@@**************************************************************************
**********                                                           **********
*******                            VARIABLES                            *******
**********                                                           **********
******************************************************************************/

#ifdef CPPvmThread
#ifndef WIN32
/*@@***************************   VARIABLE   **********************************
***
@VN  VARIABLE NAME : unixCommunicationMutex
@VD  DESCRIPTION   : unix mutex variable for send/rec communication
@VT  TYPE          : pthread_mutex_t
***
******************************************************************************/
pthread_mutex_t cppvmGlobalVariables::unixCommunicationMutex = PTHREAD_MUTEX_INITIALIZER;

/*@@***************************   VARIABLE   **********************************
***
@VN  VARIABLE NAME : unixMutexFunction
@VD  DESCRIPTION   : unix mutex variable for 'cppvmMutex' functions
@VT  TYPE          : pthread_mutex_t
***
******************************************************************************/
pthread_mutex_t cppvmGlobalVariables::unixMutexFunction = PTHREAD_MUTEX_INITIALIZER;
#endif
#endif

#ifdef CPPvmThread
#ifdef WIN32
/*@@***************************   VARIABLE   **********************************
***
@VN  VARIABLE NAME : communicationMutex
@VD  DESCRIPTION   : mutex variable for send/rec communication
@VT  TYPE          : cppvmInternalMutex
***
******************************************************************************/
cppvmInternalMutex cppvmGlobalVariables::communicationMutex;

/*@@***************************   VARIABLE   **********************************
***
@VN  VARIABLE NAME : mutexFunction
@VD  DESCRIPTION   : mutex variable for 'cppvmMutex' functions
@VT  TYPE          : cppvmInternalMutex
***
******************************************************************************/
cppvmInternalMutex cppvmGlobalVariables::mutexFunction;
#else
/*@@***************************   VARIABLE   **********************************
***
@VN  VARIABLE NAME : communicationMutex
@VD  DESCRIPTION   : mutex variable for send/rec communication
@VT  TYPE          : cppvmInternalMutex
***
******************************************************************************/
cppvmInternalMutex cppvmGlobalVariables::communicationMutex(&unixCommunicationMutex);

/*@@***************************   VARIABLE   **********************************
***
@VN  VARIABLE NAME : mutexFunction
@VD  DESCRIPTION   : mutex variable for 'cppvmMutex' functions
@VT  TYPE          : cppvmInternalMutex
***
******************************************************************************/
cppvmInternalMutex cppvmGlobalVariables::mutexFunction(&unixMutexFunction);
#endif
#endif 


/*@@@**************************************************************************
**********                                                           **********
*******                             METHODS                             *******
**********                                                           **********
******************************************************************************/

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmGlobalVariables
@MK  CLASS NAME    : cppvmGlobalVariables
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : 
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : -
@MP  INOUT   : - 
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmGlobalVariables::cppvmGlobalVariables ()
{
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : ~cppvmGlobalVariables
@MK  CLASS NAME    : cppvmGlobalVariables
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : destructor 
@MU  USAGE         : ~cppvmGlobalVariables
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : cppvmGlobalVariables
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmGlobalVariables::~cppvmGlobalVariables() 
{
}

/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/

