/*@@@**************************************************************************
**********                                                           **********
*******                      IMPLEMENTATION FILE                        *******
**********                                                           **********
*******************************************************************************
@IF  FILE        : pvm_mem.cpp 
@IE  CREATED     : 31.1.1999
@IA  AUTHOR      : goerzig
@IJ  PROJECT     : cppvm
@I#  
@ID  DESCRIPTION : CPPvm remind allocated memory for PvmDataInPlace
@ID                sending
@IU  USAGE       : 
@IC  CONSTRAINTS : 
@I#  
@IR  NOTES       : 
@I#  --------------------------------------------------------------------------
@I#  Technical Information:
@I#  
@II  LANGUAGE        : C++
@II  HARDWARE        : PC 386
@II  COMPILER        : gcc version 2.7.2.3
@II  OPERATINGSYSTEM : Linux
@I#  --------------------------------------------------------------------------
@I#  Version Manager Informations:
@I#  
@IV  FILENAME    : $Source: $
@IV  AUTHOR      : $Author: $
@IV  REVISION    : $Revision: $
@IV  DATE        : $Date: $
@IV  STATE       : $State: $
@IV  LOCKER      : $Locker: $
@I#  
@IV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
// include classes for collection handling
#include "pvm_obj.h"
#include "pvm_coll.h"
// include own header
#include "pvm_mem.h"

/*@@@**************************************************************************
**********                                                           **********
*******                           VARIABLES                             *******
**********                                                           **********
******************************************************************************/
// collection for allocated memory
// delete memory after sending ("PvmDataInPlace" send method)
cppvmObjectCollection allocatedMemory;

/*@@@**************************************************************************
**********                                                           **********
*******                             METHODS                             *******
**********                                                           **********
******************************************************************************/


/*@@@**************************************************************************
**********                                                           **********
*******                            FUNCTIONS                            *******
**********                                                           **********
******************************************************************************/



/*@@****************************   FUNCTION   *********************************
***
@FN  FUNCTION NAME : cppvmCleanMemoryAfterAfterSend
@FA  AUTHOR        : goerzig
@F#  
@FD  DESCRIPTION   : clean the allocated memory after sending
@FU  USAGE         : 
@FC  CONSTRAINTS   : 
@FS  SIDE EFFECTS  : 
@F#  
@FR  NOTES         : 
@F#  --------------------------------------------------------------------------
@F#  Function Parameter:
@F#  
@FP  IN      : 
@FP  INOUT   : 
@FP  OUT     : 
@FP  RETURNS : 
******************************************************************************/
void
cppvmCleanMemoryAfterSend()
{
  allocatedMemory.clean();
}

/*@@****************************   FUNCTION   *********************************
***
@FN  FUNCTION NAME : cppvmAddToSendStack
@FA  AUTHOR        : goerzig
@F#  
@FD  DESCRIPTION   : add allocated memory to the send stack
@FU  USAGE         : 
@FC  CONSTRAINTS   : 
@FS  SIDE EFFECTS  : 
@F#  
@FR  NOTES         : 
@F#  --------------------------------------------------------------------------
@F#  Function Parameter:
@F#  
@FP  IN      : 
@FP  INOUT   : 
@FP  OUT     : 
@FP  RETURNS : 
******************************************************************************/
void
cppvmAddToSendStack(cppvmObject *obj)
{
  allocatedMemory.add(obj);
}


/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/



