/*@@@**************************************************************************
**********                                                           **********
*******                      IMPLEMENTATION FILE                        *******
**********                                                           **********
*******************************************************************************
@IF  FILE        : pvm_noha.cpp 
@IE  CREATED     : 31.07.2000
@IA  AUTHOR      : goerzig
@IJ  PROJECT     : cppvm
@I#  
@ID  DESCRIPTION : notification class for added hosts
@IU  USAGE       : 
@IC  CONSTRAINTS : 
@I#  
@IR  NOTES       : 
@I#  --------------------------------------------------------------------------
@I#  Technical Information:
@I#  
@II  LANGUAGE        : C++
@II  HARDWARE        : PC 386
@II  COMPILER        : gcc version 2.7.2.3
@II  OPERATINGSYSTEM : Linux
@I#  --------------------------------------------------------------------------
@I#  Version Manager Informations:
@I#  
@IV  FILENAME    : $Source: $
@IV  AUTHOR      : $Author: $
@IV  REVISION    : $Revision: $
@IV  DATE        : $Date: $
@IV  STATE       : $State: $
@IV  LOCKER      : $Locker: $
@I#  
@IV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/


/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/

// class header
#include "pvm_noha.h" 

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/
#define THIS_MODULE "pvm_noha.cpp"

/*@@@**************************************************************************
**********                                                           **********
*******                            VARIABLES                            *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                             METHODS                             *******
**********                                                           **********
******************************************************************************/

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationHostAdd
@MK  CLASS NAME    : cppvmNotificationHostAdd
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : default constructor
@MU  USAGE         : cppvmNotificationHostAdd
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationHostAdd::cppvmNotificationHostAdd()
  : cppvmNotification()
{
  notificationEvent=PvmHostAdd;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationHostAdd
@MK  CLASS NAME    : cppvmNotificationHostAdd
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmNotificationHostAdd
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationHostAdd::cppvmNotificationHostAdd(int msgTag)
    : cppvmNotification()
{
  set(msgTag);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationHostAdd
@MK  CLASS NAME    : cppvmNotificationHostAdd
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmNotificationHostAdd
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationHostAdd::cppvmNotificationHostAdd(int msgTag, int number)
    : cppvmNotification()
{
  set(msgTag, number);
}


/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationHostAdd
@MK  CLASS NAME    : cppvmNotificationHostAdd
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : copy constructor
@MU  USAGE         : =
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj   object to copy
@MP  INOUT   : - 
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmNotificationHostAdd::cppvmNotificationHostAdd (const 
                                                    cppvmNotificationHostAdd& obj)
    : cppvmNotification(obj)
{
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : ~cppvmNotificationHostAdd
@MK  CLASS NAME    : cppvmNotificationHostAdd
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : destructor
@MU  USAGE         : ~cppvmNotificationHostAdd()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         : 
@M#  --------------------------------------------------------------------------
@MP  IN      :
@MP  INOUT   :
@MP  OUT     : 
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationHostAdd::~cppvmNotificationHostAdd()
{
  cppvmNotification::set(PvmHostAdd, notificationMsgTag, 0, NULL);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator=
@MK  CLASS NAME    : cppvmNotificationHostAdd
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : assignment
@MU  USAGE         : =
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  info for configuration object attributes 
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmNotificationHostAdd&
cppvmNotificationHostAdd::operator= (const cppvmNotificationHostAdd& obj)
{
  cppvmNotification::operator=(obj);
  return *this;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmPrintOn
@MK  CLASS NAME    : cppvmNotificationHostAdd
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : print on stream method
@MU  USAGE         : void cppvmPrintOn(ostream& strm);
@MC  CONSTRAINTS   : 
@M#  
@MR  NOTES         : 
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : strm out stream
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationHostAdd::cppvmPrintOn(ostream& strm)
{
  if(initialized==false){
    strm << "notification object is not initialized" << endl;
  }
  else{
    strm << "Host add notification" ;
    strm << endl;
    strm << "Message Tag: " << notificationMsgTag;
    strm << " number: " << notificationNumber;
    strm << " last result: " << notificationTids;
    strm << endl;
  }
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : set
@MK  CLASS NAME    : cppvmNotificationHostAdd
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : set method
@MU  USAGE         : set(int msgTag);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationHostAdd::set(int msgTag)
{
  cppvmNotification::set(PvmHostAdd, msgTag);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : set
@MK  CLASS NAME    : cppvmNotificationHostAdd
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : set method
@MU  USAGE         : set(int msgTag, int number);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationHostAdd::set(int msgTag, int number)
{
  cppvmNotification::set(PvmHostAdd, msgTag, number, NULL);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : reset
@MK  CLASS NAME    : cppvmNotificationHostAdd
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : reset number of host add messages
@MU  USAGE         : reset(int number);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationHostAdd::reset(int number)
{
  CPPvmNotificationThrowIfNotInit

  cppvmNotification::set(PvmHostAdd, notificationMsgTag, 
                         number, NULL);
}


/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : get the task ids of the added hosts
@MK  CLASS NAME    : cppvmNotificationHostAdd
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : get method
@MU  USAGE         : cppvmArrayInt getAddedHostDaemonTids()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmArrayInt
cppvmNotificationHostAdd::getAddedHostDaemonTids()
{
  CPPvmNotificationThrowIfNotInit
    
  return receivedTids;
}

/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/

