/*@@@**************************************************************************
**********                                                           **********
*******                      IMPLEMENTATION FILE                        *******
**********                                                           **********
*******************************************************************************
@IF  FILE        : pvm_nohd.cpp 
@IE  CREATED     : 31.07.2000
@IA  AUTHOR      : goerzig
@IJ  PROJECT     : cppvm
@I#  
@ID  DESCRIPTION : notification class for deleted hosts
@IU  USAGE       : 
@IC  CONSTRAINTS : 
@I#  
@IR  NOTES       : 
@I#  --------------------------------------------------------------------------
@I#  Technical Information:
@I#  
@II  LANGUAGE        : C++
@II  HARDWARE        : PC 386
@II  COMPILER        : gcc version 2.7.2.3
@II  OPERATINGSYSTEM : Linux
@I#  --------------------------------------------------------------------------
@I#  Version Manager Informations:
@I#  
@IV  FILENAME    : $Source: $
@IV  AUTHOR      : $Author: $
@IV  REVISION    : $Revision: $
@IV  DATE        : $Date: $
@IV  STATE       : $State: $
@IV  LOCKER      : $Locker: $
@I#  
@IV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/


/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/

// class header
#include "pvm_nohd.h" 

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/
#define THIS_MODULE "pvm_nohd.cpp"

/*@@@**************************************************************************
**********                                                           **********
*******                            VARIABLES                            *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                             METHODS                             *******
**********                                                           **********
******************************************************************************/

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationHostDelete
@MK  CLASS NAME    : cppvmNotificationHostDelete
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : default constructor
@MU  USAGE         : cppvmNotificationHostDelete
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationHostDelete::cppvmNotificationHostDelete()
  : cppvmNotification()
{
  notificationEvent=PvmHostDelete;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationHostDelete
@MK  CLASS NAME    : cppvmNotificationHostDelete
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmNotificationHostDelete
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationHostDelete::cppvmNotificationHostDelete(int msgTag)
    : cppvmNotification()
{
  set(msgTag);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationHostDelete
@MK  CLASS NAME    : cppvmNotificationHostDelete
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmNotificationHostDelete
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationHostDelete::cppvmNotificationHostDelete(int msgTag, int cnt, 
                                                         int* tids)
    : cppvmNotification()
{
  set(msgTag, cnt, tids);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationHostDelete
@MK  CLASS NAME    : cppvmNotificationHostDelete
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmNotificationHostDelete
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationHostDelete::cppvmNotificationHostDelete(int msgTag, 
                                                         cppvmArrayInt& tids)
    : cppvmNotification()
{
  set(msgTag, tids);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationHostDelete
@MK  CLASS NAME    : cppvmNotificationHostDelete
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmNotificationHostDelete
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationHostDelete::cppvmNotificationHostDelete(int msgTag, 
                                                         char *hostName)
    : cppvmNotification()
{
  set(msgTag, hostName);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationHostDelete
@MK  CLASS NAME    : cppvmNotificationHostDelete
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : copy constructor
@MU  USAGE         : =
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj   object to copy
@MP  INOUT   : - 
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmNotificationHostDelete::cppvmNotificationHostDelete (const 
                                                      cppvmNotificationHostDelete& obj)
    : cppvmNotification(obj)
{
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : ~cppvmNotificationHostDelete
@MK  CLASS NAME    : cppvmNotificationHostDelete
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : destructor
@MU  USAGE         : ~cppvmNotificationHostDelete()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         : 
@M#  --------------------------------------------------------------------------
@MP  IN      :
@MP  INOUT   :
@MP  OUT     : 
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationHostDelete::~cppvmNotificationHostDelete()
{
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator=
@MK  CLASS NAME    : cppvmNotificationHostDelete
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : assignment
@MU  USAGE         : =
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  info for configuration object attributes 
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmNotificationHostDelete&
cppvmNotificationHostDelete::operator= (const cppvmNotificationHostDelete& obj)
{
  cppvmNotification::operator=(obj);
  return *this;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmPrintOn
@MK  CLASS NAME    : cppvmNotificationHostDelete
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : print on stream method
@MU  USAGE         : void cppvmPrintOn(ostream& strm);
@MC  CONSTRAINTS   : 
@M#  
@MR  NOTES         : 
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : strm out stream
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationHostDelete::cppvmPrintOn(ostream& strm)
{
  if(initialized==false){
    strm << "notification object is not initialized" << endl;
  }
  else{
    strm << "Exiting task notification" ;
    strm << endl;
    strm << "Message Tag: " << notificationMsgTag;
    strm << " task ids: " << notificationTids;
    strm << endl;
  }
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : set
@MK  CLASS NAME    : cppvmNotificationHostDelete
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : set method
@MU  USAGE         : set(int msgTag);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationHostDelete::set(int msgTag)
{
  cppvmNotification::set(PvmHostDelete, msgTag);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : set
@MK  CLASS NAME    : cppvmNotificationHostDelete
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : set method
@MU  USAGE         : set(int msgTag, int cnt, int* tids);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationHostDelete::set(int msgTag, int cnt, int* tids)
{
  cppvmNotification::set(PvmHostDelete, msgTag, cnt, tids);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : set
@MK  CLASS NAME    : cppvmNotificationHostDelete
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : set method
@MU  USAGE         : set(int msgTag, cppvmArrayInt& tids);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationHostDelete::set(int msgTag, cppvmArrayInt& tids)
{
  cppvmNotification::set(PvmHostDelete, msgTag, tids.numElems(), tids.getPtr());
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : set
@MK  CLASS NAME    : cppvmNotificationHostDelete
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : set method
@MU  USAGE         : set(int msgTag, char *hostName);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationHostDelete::set(int msgTag, char *hostName)
{
  hostDeleteDaemonTids.resize(1);
  hostDeleteDaemonTids[0] = getHostDaemonTid(hostName);
  cppvmNotification::set(PvmHostDelete, msgTag, 1, hostDeleteDaemonTids.getPtr());
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : get the task id of the exited task
@MK  CLASS NAME    : cppvmNotificationHostDelete
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : get method
@MU  USAGE         : int getDeletedHostDaemonTid()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
int
cppvmNotificationHostDelete::getDeletedHostDaemonTid()
{
  CPPvmNotificationThrowIfNotInit

  return receivedTids[0];
}

/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/

