/*@@@**************************************************************************
**********                                                           **********
*******                      IMPLEMENTATION FILE                        *******
**********                                                           **********
*******************************************************************************
@IF  FILE        : pvm_note.cpp 
@IE  CREATED     : 30.07.2000
@IA  AUTHOR      : goerzig
@IJ  PROJECT     : cppvm
@I#  
@ID  DESCRIPTION : notification class for exited tasks
@IU  USAGE       : 
@IC  CONSTRAINTS : 
@I#  
@IR  NOTES       : 
@I#  --------------------------------------------------------------------------
@I#  Technical Information:
@I#  
@II  LANGUAGE        : C++
@II  HARDWARE        : PC 386
@II  COMPILER        : gcc version 2.7.2.3
@II  OPERATINGSYSTEM : Linux
@I#  --------------------------------------------------------------------------
@I#  Version Manager Informations:
@I#  
@IV  FILENAME    : $Source: $
@IV  AUTHOR      : $Author: $
@IV  REVISION    : $Revision: $
@IV  DATE        : $Date: $
@IV  STATE       : $State: $
@IV  LOCKER      : $Locker: $
@I#  
@IV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/


/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/

// class header
#include "pvm_note.h" 

/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/
#define THIS_MODULE "pvm_note.cpp"

/*@@@**************************************************************************
**********                                                           **********
*******                            VARIABLES                            *******
**********                                                           **********
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                             METHODS                             *******
**********                                                           **********
******************************************************************************/

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationTaskExit
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : default constructor
@MU  USAGE         : cppvmNotificationTaskExit
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationTaskExit::cppvmNotificationTaskExit()
  : cppvmNotification()
{
  notificationEvent=PvmTaskExit;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationTaskExit
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmNotificationTaskExit
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationTaskExit::cppvmNotificationTaskExit(int msgTag)
    : cppvmNotification()
{
  set(msgTag);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationTaskExit
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmNotificationTaskExit
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationTaskExit::cppvmNotificationTaskExit(int msgTag, 
                                                     int number, int* tids)
    : cppvmNotification()
{
  set(msgTag, number, tids);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationTaskExit
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmNotificationTaskExit
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationTaskExit::cppvmNotificationTaskExit(int msgTag, cppvmArrayInt& tids)
    : cppvmNotification()
{
  set(msgTag, tids);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationTaskExit
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmNotificationTaskExit
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationTaskExit::cppvmNotificationTaskExit(int msgTag, 
                                                     cppvmSpawnConnection& child)
    : cppvmNotification()
{
  set(msgTag, child);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationTaskExit
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmNotificationTaskExit
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationTaskExit::cppvmNotificationTaskExit(int msgTag, 
                                                     cppvmSpawnMultiConnection& children)
    : cppvmNotification()
{
  set(msgTag, children);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationTaskExit
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmNotificationTaskExit
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationTaskExit::cppvmNotificationTaskExit(int msgTag, 
                                                     cppvmTask& task)
    : cppvmNotification()
{
  set(msgTag, task);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationTaskExit
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmNotificationTaskExit
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationTaskExit::cppvmNotificationTaskExit(int msgTag, char* taskName)
    : cppvmNotification()
{
  set(msgTag, taskName);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmNotificationTaskExit
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : copy constructor
@MU  USAGE         : =
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj   object to copy
@MP  INOUT   : - 
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmNotificationTaskExit::cppvmNotificationTaskExit (const 
                                                      cppvmNotificationTaskExit& obj)
    : cppvmNotification(obj)
{
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : ~cppvmNotificationTaskExit
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : destructor
@MU  USAGE         : ~cppvmNotificationTaskExit()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         : 
@M#  --------------------------------------------------------------------------
@MP  IN      :
@MP  INOUT   :
@MP  OUT     : 
@MP  RETURNS : 
******************************************************************************/
cppvmNotificationTaskExit::~cppvmNotificationTaskExit()
{
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator=
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : assignment
@MU  USAGE         : =
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  info for configuration object attributes 
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmNotificationTaskExit&
cppvmNotificationTaskExit::operator= (const cppvmNotificationTaskExit& obj)
{
  cppvmNotification::operator=(obj);
  return *this;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmPrintOn
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : print on stream method
@MU  USAGE         : void cppvmPrintOn(ostream& strm);
@MC  CONSTRAINTS   : 
@M#  
@MR  NOTES         : 
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : strm out stream
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationTaskExit::cppvmPrintOn(ostream& strm)
{
  if(initialized==false){
    strm << "notification object is not initialized" << endl;
  }
  else{
    strm << "Exiting task notification" ;
    strm << endl;
    strm << "Message Tag: " << notificationMsgTag;
    strm << " task ids: " << notificationTids;
    strm << " last result: " << notificationTids[0];
    strm << endl;
  }
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : set
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : set method
@MU  USAGE         : set(int msgTag);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationTaskExit::set(int msgTag)
{
  exitTaskIds.resize(0);
  cppvmNotification::set(PvmTaskExit, msgTag);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : set
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : set method
@MU  USAGE         : set(int msgTag, int number, int* tids);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationTaskExit::set(int msgTag, int number, int* tids)
{
  exitTaskIds.resize(0);
  cppvmNotification::set(PvmTaskExit, msgTag, number, tids);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : set
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : set method
@MU  USAGE         : set(int msgTag, cppvmArrayInt& tids);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationTaskExit::set(int msgTag, cppvmArrayInt& tids)
{
  exitTaskIds.resize(0);
  cppvmNotification::set(PvmTaskExit, msgTag, tids.numElems(), tids.getPtr());
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : set
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : set method
@MU  USAGE         : set(int msgTag, cppvmSpawnConnection& child);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationTaskExit::set(int msgTag, cppvmSpawnConnection& child)
{
  exitTaskIds.resize(1);
  exitTaskIds[0] = child.getChildTid();
  cppvmNotification::set(PvmTaskExit, msgTag, 1, exitTaskIds.getPtr());
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : set
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : set method
@MU  USAGE         : set(int msgTag, cppvmSpawnMultiConnection& children);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationTaskExit::set(int msgTag, cppvmSpawnMultiConnection& children)
{
  unsigned int i;
  exitTaskIds.resize(children.numElems());
  for (i=0;i<children.numElems();i++){
    exitTaskIds[i] = children[i].getChildTid();
  }
  cppvmNotification::set(PvmTaskExit, msgTag, children.numElems(), exitTaskIds.getPtr());
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : set
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : set method
@MU  USAGE         : set(int msgTag, cppvmTask& task);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationTaskExit::set(int msgTag, cppvmTask& task)
{
  exitTaskIds.resize(1);
  exitTaskIds[0] = task.getTid();
  cppvmNotification::set(PvmTaskExit, msgTag, 1, exitTaskIds.getPtr());
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : set
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : set method
@MU  USAGE         : set(int msgTag, char *taskName);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmNotificationTaskExit::set(int msgTag, char *taskName)
{
  exitTaskIds.resize(1);
  exitTaskIds[0] = getTidOfTask(taskName);
  cppvmNotification::set(PvmTaskExit, msgTag, 1, exitTaskIds.getPtr());
}


/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : get the task id of the exited task
@MK  CLASS NAME    : cppvmNotificationTaskExit
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : get method
@MU  USAGE         : int getExitTid()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
int
cppvmNotificationTaskExit::getExitTid()
{
  CPPvmNotificationThrowIfNotInit

  return receivedTids[0]  ;
}

/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/

