/*@@@**************************************************************************
**********                                                           **********
*******                      IMPLEMENTATION FILE                        *******
**********                                                           **********
*******************************************************************************
@IF  FILE        : pvm_syco.cpp 
@IE  CREATED     : 25.6.1998
@IA  AUTHOR      : goerzig
@IJ  PROJECT     : cppvm
@I#  
@ID  DESCRIPTION : pvm system collection
@IU  USAGE       : 
@IC  CONSTRAINTS : 
@I#  
@IR  NOTES       : 
@I#  --------------------------------------------------------------------------
@I#  Technical Information:
@I#  
@II  LANGUAGE        : C++
@II  HARDWARE        : PC 386
@II  COMPILER        : gcc version 2.7.2.3
@II  OPERATINGSYSTEM : Linux
@I#  --------------------------------------------------------------------------
@I#  Version Manager Informations:
@I#  
@IV  FILENAME    : $Source: $
@IV  AUTHOR      : $Author: $
@IV  REVISION    : $Revision: $
@IV  DATE        : $Date: $
@IV  STATE       : $State: $
@IV  LOCKER      : $Locker: $
@I#  
@IV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_syco.h"


/*@@@**************************************************************************
**********                                                           **********
*******                            CONSTANTS                            *******
**********                                                           **********
******************************************************************************/
#define THIS_MODULE "pvm_syco.cpp"

/*@@@**************************************************************************
**********                                                           **********
*******                             METHODS                             *******
**********                                                           **********
******************************************************************************/

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmProcessHandlingCollection
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmProcessHandlingCollection
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmProcessHandlingCollection::cppvmProcessHandlingCollection()
    : cppvmProcessHandling()
{
  // init object collection
  size = 0;
  elems = new cppvmProcessHandling*[size];
  num = 0;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : ~cppvmProcessHandlingCollection
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : destructor
@MU  USAGE         : ~cppvmProcessHandlingCollection
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmProcessHandlingCollection::~cppvmProcessHandlingCollection()
{
  clean();
  delete [] elems;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator==
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : equality
@MU  USAGE         : ==
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object to test
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
bool
cppvmProcessHandlingCollection::operator== (const cppvmProcessHandlingCollection& obj)
{
  unsigned int i;
  
  if(cppvmIsSame(obj)){
    return true;
  }
  if(num !=  obj.num){
    return false;
  }
  for (i=0; i<num; i++){
    if (elems[i] != obj.elems[i]){
      return false;
    }
  }
  return true;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator==
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : equality
@MU  USAGE         : ==
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object to test
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
bool
cppvmProcessHandlingCollection::operator== (const cppvmProcessHandlingCollection& obj) const
{
  unsigned int i;
  
  if(cppvmIsSame(obj)){
    return true;
  }
  if(num !=  obj.num){
    return false;
  }
  for (i=0; i<num; i++){
    if (elems[i] != obj.elems[i]){
      return false;
    }
  }
  return true;
}


/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmPrintOn
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : print method for << operator
@MU  USAGE         : cppvmPrintOn()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : strm  stream to print object on
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmProcessHandlingCollection::cppvmPrintOn(ostream& strm)
{
  unsigned int i;

  strm << "( ";
  for(i=0; i<num; i++){
    strm << *elems[i];
    strm << " ";
  }
  strm << ")";
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmScanFrom
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : scan method for << operator
@MU  USAGE         : cppvmScanFrom()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : strm  stream to scan object from
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmProcessHandlingCollection::cppvmScanFrom(istream& /*strm*/)
{
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : remove
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : remove element (cppvmProcessHandling pointer) from collection
@MU  USAGE         : remove(obj)
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj   cppvmProcessHandling to remove
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmProcessHandlingCollection::remove(cppvmProcessHandling& obj)
{
  unsigned int i;
  
  for(i=0; i<num; i++){
    if(elems[i]->cppvmIsSame(obj)){
      num = num - 1;
      delete elems[i];
      shiftLeft((unsigned int) i, (unsigned int) num);
      return;
    }
  }
  CPPvmInternalThrow( cppvmExceptionOutOfRange(THIS_MODULE,
                                               "cppvmProcessHandlingCollection",
                                               "remove(cppvmProcessHandling&)",
                                               "Object not in collection"));
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : add
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : add pointer to an element to collection
@MU  USAGE         : add(cppvmProcessHandling *objPtr)
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj   pointer to cppvmProcessHandling to add
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmProcessHandlingCollection::add(cppvmProcessHandling *objPtr)
{
  // dont add same collection to collection (endless recursion)
  if(cppvmIsSame(*objPtr)){
    return;
  }

  unsigned int newSize;
  
  if (num >= size){
    if(size==0){
      newSize = 10;
    }
    else{
      newSize = size + 10;
    }
    resize(newSize);
  }
  elems[num] = objPtr;

  num = num + 1;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : remove
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : remove element (cppvmProcessHandling pointer) from collection
@MU  USAGE         : remove(cppvmProcessHandling *objPtr)
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj   pointer to cppvmProcessHandling to remove
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmProcessHandlingCollection::remove(cppvmProcessHandling *objPtr)
{
  unsigned int i;
  
  for(i=0; i<num; i++){
    if(elems[i]->cppvmIsSame(*objPtr)){
      num = num - 1;
      delete elems[i];
      shiftLeft((unsigned int) i, (unsigned int) num);
      return;
    }
  }
  CPPvmInternalThrow( cppvmExceptionOutOfRange(THIS_MODULE,
                                               "cppvmProcessHandlingCollection",
                                               "remove(T&)",
                                               "Object not in collection"));
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : remove
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : remove element (cppvmProcessHandling pointer) from collection
@MU  USAGE         : remove(unsigned int)
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : i  index of object to remove
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmProcessHandlingCollection::remove(unsigned int i)
{
  if(i >=num){
    CPPvmInternalThrow( cppvmExceptionOutOfRange(THIS_MODULE,
                                                 "cppvmProcessHandlingCollection",
                                                 "remove(unsigned int)",
                                                 "Bad index"));
  }
  num = num - 1;
  delete elems[i];
  shiftLeft((unsigned int) i, (unsigned int) num);

  return;
}


/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : clean
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : remove all elements (cppvmProcessHandling pointer) from collection
@MD                  and remove references
@MU  USAGE         : clean()
@MC  CONSTRAINTS   : 
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmProcessHandlingCollection::clean()
{
  if(size==0){
    // collection is clean
    return;
  }

  unsigned int i;

  for(i=0; i<num; i++){
    delete elems[i];
  }

  delete [] elems;
  
  size = 0;
  elems = new cppvmProcessHandling*[size];
  num = 0;

}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmProcessHandlingCollection
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : append another collection to this collection; 
@MD                  the appended collection is deleted
@MU  USAGE         : void append(cppvmProcessHandlingCollection *objColl);
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : objColl   collection to append
@MP  INOUT   : - 
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
void
cppvmProcessHandlingCollection::append(cppvmProcessHandlingCollection *objColl)
{
  unsigned int i;

  // copy all object pointer
  for (i=0; i<(objColl->num); i++){
    add(objColl->elems[i]);
  }
  // set num elem of appended collection to NULL
  // DO NOT delete objects, otherwise they are gone forever
  objColl->num=0;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : resize
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : rezise collection length
@MD                  if the new size is smaller than the current size, 
@MD                  nothing is done
@MU  USAGE         : resize(unsigned int)
@MU                  this can be done explicit after creating a new collection
@MU                  or implicit by adding an object to an empty collection
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : newSize   new size 
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmProcessHandlingCollection::resize(unsigned int newSize)
{
  cppvmProcessHandling** tmp;

  if(newSize < num){
    return;
  }
  // create new array
  size = newSize;
  tmp = new cppvmProcessHandling* [size];

  // copy all object pointer
  if(num>0){
    // copy all object pointer
    memcpy((void*) tmp, (void*) elems, sizeof(cppvmProcessHandling*) * num);
  }

  // delete old array
  delete [] elems;
  elems = tmp;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : swap
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : swap two members of the collection
@MU  USAGE         : swap(int index1, int index2);
@MC  CONSTRAINTS   : 
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : index1   index of the first cppvmProcessHandling*
@MP            index2   index of the second cppvmProcessHandling*
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmProcessHandlingCollection::swap(unsigned int index1, unsigned int index2)
{
  cppvmProcessHandling *tmp;

  if (index1>= num || index2 >= num){
    CPPvmInternalThrow( cppvmExceptionOutOfRange(PVM_SYCO_MODULE,
                                               "cppvmProcessHandlingCollection",
                                               "swap",
                                               "index1 or index2 > collection length"));
  }

  tmp = elems[index1];
  elems[index1] = elems[index2];
  elems[index2] = tmp;
}


/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : sort
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : sorts the members of the collection by the given compare
@MD                  function with the direct insert method
@MU  USAGE         : sort(pvmSysCollCompFctPtr cmpPtr);
@MC  CONSTRAINTS   : the compare function MUST be usable for all cppvmProcessHandlings
@MC                  in the collection
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : cmpPtr   compare function for objects
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmProcessHandlingCollection::sort(pvmSysCollCompFctPtr cmpPtr)
{
  cppvmProcessHandling *tmp;
  unsigned int i,j;
  
  // sort here
  for(i=1; i<num; i++){
    tmp = elems[i];
    j=i;
    while((j>0) && cmpPtr(elems[j-1],tmp)){
      elems[j] = elems[j-1];
      j--;
    }
    elems[j] = tmp;
  }

}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : shiftLeft
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : shift all object pointers to the left to keep 
@MD                  the collection ordered
@MU  USAGE         : shiftLeft(unsigned int indexMin,
@MU                            unsigned int indexMax)
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         : example: collection(a,b,c,d,e)
@MR                  collection.shiftLeft(2,4) -> collection(a,b,d,e,?)
@MR                  
@MR                  
@M#  --------------------------------------------------------------------------
@MP  IN      : indexMin  the collection is shifted left up to this element
@MP            indexMax  all objects up to this index are shifted
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmProcessHandlingCollection::shiftLeft(unsigned int indexMin,
                      unsigned int indexMax)
{
  if(indexMin > indexMax){
    return;
  }
  
  unsigned int numCopy = indexMax-indexMin;
  if(numCopy>0){
    // copy all object pointer
    memmove((void*) &elems[indexMin], (void*) &elems[indexMin+1], 
           sizeof(cppvmProcessHandling*) * numCopy);
  }
}


/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator[]
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : access to the objects in the collection
@MU  USAGE         : []
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : i  object index in collection
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmProcessHandling&
cppvmProcessHandlingCollection::operator[] (unsigned int i)
{
#ifndef CPPvmFastAccess
  if (i>= num){
    CPPvmInternalThrow( cppvmExceptionOutOfRange(PVM_SYCO_MODULE,
                                                 "cppvmProcessHandlingCollection",
                                                 "operator[]",
                                                 "index > collection length"));
  }
#endif
  return *(elems[i]);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : getObjPtr
@MK  CLASS NAME    : cppvmProcessHandlingCollection
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : access to the pointer of objects in the collection
@MU  USAGE         :  getObjPtr(unsigned int i)
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : i  object index in collection
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmProcessHandling*
cppvmProcessHandlingCollection::getObjPtr(unsigned int i)
{
#ifndef CPPvmFastAccess
  if (i>= num){
    CPPvmInternalThrow( cppvmExceptionOutOfRange(PVM_SYCO_MODULE,
                                                 "cppvmProcessHandlingCollection",
                                                 "getObjPtr",
                                                 "index > collection length"));
  }
#endif
  return elems[i];
}

/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/

