/*@@@**************************************************************************
**********                                                           **********
*******                      IMPLEMENTATION FILE                        *******
**********                                                           **********
*******************************************************************************
@IF  FILE        : pvm_task.cpp 
@IE  CREATED     : 6.2.1998
@IA  AUTHOR      : goerzig
@IJ  PROJECT     : cppvm
@I#  
@ID  DESCRIPTION : pvm task description class
@IU  USAGE       : 
@IC  CONSTRAINTS : 
@I#  
@IR  NOTES       : 
@I#  --------------------------------------------------------------------------
@I#  Technical Information:
@I#  
@II  LANGUAGE        : C++
@II  HARDWARE        : PC 386
@II  COMPILER        : gcc version 2.7.2.3
@II  OPERATINGSYSTEM : Linux
@I#  --------------------------------------------------------------------------
@I#  Version Manager Informations:
@I#  
@IV  FILENAME    : $Source: $
@IV  AUTHOR      : $Author: $
@IV  REVISION    : $Revision: $
@IV  DATE        : $Date: $
@IV  STATE       : $State: $
@IV  LOCKER      : $Locker: $
@I#  
@IV  VERSION HISTORY : $Log: $
*******************************************************************************
*****       (C) COPYRIGHT Steffen Goerzig - All Rights Reserved           *****
******************************************************************************/

/*@@@**************************************************************************
**********                                                           **********
*******                           INCLUDES                              *******
**********                                                           **********
******************************************************************************/
#include "pvm_task.h"

/*@@@**************************************************************************
**********                                                           **********
*******                 CONSTANTS FOR TYPE DEFINITIONS                  *******
**********                                                           **********
******************************************************************************/
#define THIS_MODULE "pvm_task.cpp"

/*@@@**************************************************************************
**********                                                           **********
*******                           VARIABLES                             *******
**********                                                           **********
******************************************************************************/
CPPvmBuildInMsgTagMethodsDefinition(cppvmTask,
                                      CPPvmMsgTagClassTask)

/*@@@**************************************************************************
**********                                                           **********
*******                             METHODS                             *******
**********                                                           **********
******************************************************************************/


/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmTask
@MK  CLASS NAME    : cppvmTask
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor
@MU  USAGE         : cppvmTask
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmTask::cppvmTask()
    : cppvmObject()
{
  contextId = 0;
  tid = 0;
  name = "";
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmTask
@MK  CLASS NAME    : cppvmTask
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : constructor, init variables
@MU  USAGE         : cppvmTask(int tid_, int contextId_,cppvmString name_)
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : tid_      task tid 
@MP            contextId_  contextId of the task 
@MP            name_     name of the tid
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmTask::cppvmTask(int tid_,
                 int contextId_,
                 cppvmString name_)
    : cppvmObject(), tid(tid_), contextId(contextId_)
{
  name = name_;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmTask
@MK  CLASS NAME    : cppvmTask
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : copy constructor
@MU  USAGE         : =
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj   object to copy
@MP  INOUT   : - 
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmTask::cppvmTask (const cppvmTask& obj)
    : cppvmObject(obj),  tid(obj.tid), contextId(obj.contextId)
{
  name = obj.name;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : ~cppvmTask
@MK  CLASS NAME    : cppvmTask
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : destructor
@MU  USAGE         : ~cppvmTask
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
cppvmTask::~cppvmTask()
{
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator=
@MK  CLASS NAME    : cppvmTask
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : assignment
@MU  USAGE         : =
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object to assign
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
cppvmTask&
cppvmTask::operator= (const cppvmTask& obj)
{
  // no self-assignment
  if(cppvmIsSame(obj)){
    return *this;
  }
  
  tid = obj.tid;
  contextId = obj.contextId;
  name = obj.name;
  
  return *this;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator==
@MK  CLASS NAME    : cppvmTask
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : equality
@MU  USAGE         : ==
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object to test
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
bool
cppvmTask::operator== (const cppvmTask& obj)
{
  return (tid     == obj.tid  &&
          contextId == obj.contextId &&
          name    == obj.name);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : operator==
@MK  CLASS NAME    : cppvmTask
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : equality
@MU  USAGE         : ==
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : obj  object to test
@MP  INOUT   : -
@MP  OUT     : -
@MP  RETURNS : -
******************************************************************************/
bool
cppvmTask::operator== (const cppvmTask& obj) const
{
  return (tid     == obj.tid  &&
          contextId == obj.contextId &&
          name    == obj.name);
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmPrintOn
@MK  CLASS NAME    : cppvmTask
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : print method for << operator
@MU  USAGE         : cppvmPrintOn()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : strm  stream to print object on
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmTask::cppvmPrintOn(ostream& strm)
{
  strm << "Task id: " << tid
       << " context id: " << contextId
       << " task name: " << name;
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : cppvmTransfer
@MK  CLASS NAME    : cppvmTask
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : transfer the object data from/into a buffer
@MU  USAGE         : cppvmTransfer()
@MC  CONSTRAINTS   :
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   :
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmTask::cppvmTransfer()
{
  cppvmTransferInt(&tid);
  cppvmTransferInt(&contextId);
  name.cppvmTransfer();
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : killTask
@MK  CLASS NAME    : cppvmTask
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : kill the task(s) of this parent process 
@MU  USAGE         : void killTask()
@MC  CONSTRAINTS   : 
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : 
@MP  OUT     :
@MP  RETURNS : 
******************************************************************************/
void
cppvmTask::killTask()
{
  int info;
  
  // killing spawned processes 
  info = pvm_kill(tid);
  if(info < 0){
    CPPvmInternalThrow( cppvmExceptionBadResult(THIS_MODULE,
                                                "cppvmTask",
                                                "killTask",
                                                "cannot kill task process."));
  }
}

/*@@*****************************   METHOD   **********************************
***
@MN  METHOD NAME   : halt
@MK  CLASS NAME    : cppvmTask
@MA  AUTHOR        : goerzig
@M#  
@MD  DESCRIPTION   : shut down the entire \pvm{} system
@MU  USAGE         : void halt()
@MC  CONSTRAINTS   : 
@M#  
@MR  NOTES         :
@M#  --------------------------------------------------------------------------
@MP  IN      : 
@MP  INOUT   : 
@MP  OUT     : 
@MP  RETURNS : 
******************************************************************************/
void
cppvmTask::halt()
{
  int info;
  info = pvm_halt();
  
  if(info < 0){
    CPPvmInternalThrow( cppvmExceptionBadResult(THIS_MODULE,
                                                "cppvmTask",
                                                "halt",
                                                "local pvmd is not responding"));
  }
}

/*@@@**************************************************************************
**********                                                           **********
*******                           END OF FILE                           *******
**********                                                           **********
******************************************************************************/

